<?php /**
     * Short description of class CBackadminsController
     *
     * @access private
     
     */

     class CBackadminsController extends CAppController {
         
        private $_iNumberItemsPerPage = 100;  

        public function CBackadminsController(){
            parent::CAppController();
            $this->setType( C_BACKEND );
            $this->_someModels = array("CAdmin", "CUser");
            $this->_someControllers = array("CCsvsController");
            $this->_sLayout = "backlayout";
        }
        public function index() {
            try {
                $someParts = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);
                
                $iCodeLang = $someParts[0]['id'];
                
                $someValues = array(
                     'p_sColumns' => 'a.*, c.name as country, r.name as region',
                    "p_sTable" => "((admins a  LEFT JOIN countries c ON a.countries_id = c.id)  LEFT JOIN regions r ON r.countries_id = c.id)",
                    "p_sWhere" => "(a.countries_id = c.id and c.languages_id = $iCodeLang and a.admprofiles_id <> ".C_PROFILE_ROOT.") 
                    and (a.regions_id = r.id and r.languages_id = $iCodeLang)",
                    'p_sOrder' => 'a.id asc',
                    'p_sLimit' => $this->_iNumberItemsPerPage);

                $someData = $this->paginate('CAdmin', 'index', 'backadmins',$someValues);
                
                 $oSession = new CAppSession();
                $oSession->__setArray("someToCsv",$someValues);

                $sLastInserted = 0;
                if ( isset ($this->_someParameters[0]) )
                    $sLastInserted = $this->_someParameters[0];

                $someColumns = $this->_oAdmin->describeColumns('admins',true);
                $this->_oView->add('someColumns',$someColumns);
                $this->_oView->add('someData',$someData);

                $this->_oView->add('sLastInserted',$sLastInserted);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',"Backadmins");
                $this->_oLayout->add('sImageMenu',"global/submenu/backadminsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(1, __("Backadmins" , $this->_sLanguage , true) , 'backadmins', "index");
             }
             catch(CException $e) {
                throw $e;
             }

        }

        public function edit($iId = null) {
            try {
                if($iId != null)
                {
                    if(isset($this->_someParameters['data']))
                    {
                        $sWhere = 'id = '.$iId;

                        if($this->_oAdmin->update($this->_someParameters['data'],$sWhere,false) == C_WARNING_UPDATEDOK)
                        {
                             //First we have to call the index View to create variables that will be used in the View
                            $this->index();

                            //Second we have to set the view that will show the controller
                            $this->_oView->set_sView('index.php');

                            $this->_oLayout->add('sTextMessage','Edit Collaborator');

                            $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                        }
                        else
                        {
                            $this->_oView->add('someData',$this->_someParameters['data']);
                            $this->_oLayout->add('sTextMessage','Collaborator NOT edited');
                            $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                        }

                    }
                    else
                    {
                        $sWhere = 'id = '.$iId;

                        $someValues = array(
                            'p_sColumns' => '*',
                            'p_sWhere' => $sWhere);

                        if($this->_oAdmin->select($someValues) == C_WARNING_SELECTEDOK)
                        {
                            $someData = $this->_oAdmin->get_someData();

                            $someValues['backadmins'] = $someData[0];

                            $this->_oView->add('someData',$someValues);
                        }
                        else
                        {
                             //First we have to call the index View to create variables that will be used in the View
                            $this->index();

                            //Second we have to set the view that will show the controller
                            $this->_oView->set_sView('index.php');

                            $this->_oLayout->add('sTextMessage','Collaborator not found');

                            $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                        }

                    }

                    $this->_oView->add('iId',$iId);

                }
                else
                {
                     //First we have to call the index View to create variables that will be used in the View
                    $this->index();

                    //Second we have to set the view that will show the controller
                    $this->_oView->set_sView('index.php');

                    $this->_oLayout->add('sTextMessage','Missing id');
                    $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                }
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',__("Edit Collaborator" , $this->_sLanguage , true));
                $this->_oLayout->add('sImageMenu',"global/submenu/backadminsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(2, __("Edit Collaborator" , $this->_sLanguage , true) , 'backadmins', "edit/$iId");
           }
           catch(CException $e) {
                throw $e;
           }

        }

        public function add() {
            try {
                if(isset($this->_someParameters['data']))
                {
                    if($this->_oAdmin->insert( $this->_someParameters['data'] ) == C_WARNING_INSERTEDOK)
                    {
                         //First we have to call the index View to create variables that will be used in the View
                        $this->index();

                        //Second we have to set the view that will show the controller
                        $this->_oView->set_sView('index.php');
                        $this->_oView->add('sLastInserted' , $this->_oAdmin->get_iIdLastInserted() );
                        $this->_oLayout->add('sTextMessage','New Collaborator inserted');
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                    }
                    else
                    {
                        $this->_oView->add('someData',$this->_someParameters['data']);
                        $this->_oLayout->add('sTextMessage','New Collaborator NOT inserted');
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                    }
                }
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',__("Add Collaborator" , $this->_sLanguage , true));
                $this->_oLayout->add('sImageMenu',"global/submenu/backadminsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(2, __("Add Collaborator" , $this->_sLanguage , true) , 'backadmins', "add");
            }
            catch(CException $e) {
                throw $e;
            }
         }

        public function delete( $p_iId = null ) {
            try {
                 //First we have to call the index View to create variables that will be used in the View
                $this->index();

                //if you want to add extra operations to this method, you will have to do it here
                //first we have to delete
                if ( !is_null($p_iId) ) {

                    $iReturnedValue = $this->_oAdmin->delete($this->_oAdmin->get_sTable(), 'id = '.$p_iId);
                    //if the delete operation success, we will show a message with 'deleted correctly'
                    if ($iReturnedValue == C_WARNING_DELETEOK) {
                        $this->_oLayout->add('sTextMessage', __("Operation executed successfully",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                    }
                    else {
                        $this->_oLayout->add('sTextMessage', __("Operation NOT executed successffuly",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                    }

                }
                //if you want to add extra operations to this method, you will have to do it here

                $this->_oView->set_sView('index.php');
             }
             catch(CException $e) {
                throw $e;
             }
        }

        public function search() {
            try {
                  
                $someParts = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);                
                $iCodeLang = $someParts[0]['id'];
                
                $someParameters = $this->get_someParameters();
                if (isset($someParameters) && isset($someParameters['data'])) {
                      $sText = $someParameters['nameIptSearchValue'];
                      $sField = $someParameters['data']['search']['field'];
                      $sTextUpper = strtoupper(utf8_decode($sText));
                      $sTextLower = strtolower(utf8_decode($sText));

                      $someValues = array(
                            'p_sColumns' => 'a.*, c.name as country, r.name as region',
                            "p_sTable" => "((admins a  LEFT JOIN countries c ON a.countries_id = c.id)  LEFT JOIN regions r ON r.countries_id = c.id)",
                            'p_sWhere' => "((a.countries_id = c.id and c.languages_id = $iCodeLang and a.admprofiles_id <> ".C_ADMIN_USER.") 
                        and (a.regions_id = r.id and r.languages_id = $iCodeLang)) and (".
                          $sField.' LIKE "%'.$sText.'%" OR '.$sField.' LIKE "%'.$sTextLower.'%" OR '.$sField.' LIKE "%'.$sTextUpper.'%")',
                            'p_sOrder' => 'a.id asc',
                            'p_sLimit' => $this->_iNumberItemsPerPage);
                      $someData = $this->paginate('CAdmin', 'index', 'backadmins',$someValues);
                      
                       $oSession = new CAppSession();
                      $oSession->__setArray("someToCsv",$someValues);

                      $someColumns = $this->_oAdmin->describeColumns('admins',true);
                      $this->_oView->add('someColumns',$someColumns);
                      $this->_oView->add('someData',$someData);
                      $this->_oView->set_sView('index.php');
                }
                $this->_oView->add('sLastInserted',0);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_FULL_GREEN);
                $this->_oLayout->add('sTitleMenu',"Backadmins");
                $this->_oLayout->add('sImageMenu',"global/backadminsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(1, __("Backadmins" , $this->_sLanguage , true) , 'backadmins', "index");
            }
            catch(CException $e) {
                throw $e;
            }
        }
        
        
      /**
        * This function creates a csv file
        */
        public function exportcsv()
        {
            try
            {
                $oSession = new CAppSession();                
                $someToCsv = $oSession->__getArray("someToCsv");
                $this->_sLayout = 'ajax';
                if ($someToCsv != false)
                {
                    $someToCsv["p_sLimit"] = "";
                    $this->_oUser->select($someToCsv);
                    $someData = $this->_oUser->get_someData();
                    $sFileName = $this->_oCsvsController->export($someData, "backadmins");
                    
                    $this->_oView->add("sPathCsv",C_ROOT.DIRECTORY_SEPARATOR."app".DIRECTORY_SEPARATOR."uploads".DIRECTORY_SEPARATOR."csv".DIRECTORY_SEPARATOR);
                    $this->_oView->add("sFileName",$sFileName);
                }
                else
                {
                    redirect($this->link("index","backadmins"),__("There aren't data to build the csv file",$this->_sLanguage,true),C_MESSAGE_ERROR); die();
                }
                
                    
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
    }
?>