<?php

/**
 * This class manages the access to different views and controllers for different admin users.
 */
class CBackadmprofilesController extends CAppController {
    
    public function CBackadmprofilesController()
    {
            parent::CAppController();
            $this->setType( C_BACKEND );
            $this->_someModels = array("CAdmin", "CUser");
            $this->_someControllers = array("CCsvsController");
            $this->_sLayout = "backlayout";
    }
    
    /**
     * This function controls if an admin can access to a view. 
     * @param type $p_sControllerTarget The name of the controller to access
     * @param type $p_sViewTarget The name of the view to access
     * @return type If has access it will return true otherwise it will return false
     */
    public function hasAccess($p_sControllerTarget, $p_sViewTarget)
    {
        try
        {
            $bReturn = true;
            $oSession = new CAppSession();
            $iIdAdmin = $oSession->__get("idadmin");
            //if he is an admin
            if ($iIdAdmin != false)
            {                
                $someProfile = $oSession->__get("someProfile"); 
                
                if (count($someProfile)>0)
                {
                    if (isset($someProfile[0][$p_sControllerTarget]) && ($someProfile[0][$p_sControllerTarget] > C_PROFILE_ADM_NO))
                    {                        
                        
                        if (($p_sViewTarget == "edit") || ($p_sViewTarget == "delete"))
                        {
                           if  ($someProfile[0][$p_sControllerTarget] <= C_PROFILE_ADM_R) //only to edit
                           {
                               $bReturn = false;
                           }
                        }                        
                    }
                }
            }            
        }
        catch(CException $e)
        {
            throw $e;
        }
        
        return $bReturn;
    }
}

?>
