<?php /**
     * Short description of class CBackpaymentsController
     *
     * @access private
     * @author NUBESIS, <info@nubesis.com>
     */

     class CBackpaymentsController extends CAppController {
         
        private $_iNumberItemsPerPage = 100;  

        public function CBackpaymentsController(){
            parent::CAppController();
            $this->setType( C_BACKEND );
            $this->_someModels = array("CPayment", "CUser", "CCountrie", "CCitie", "CRegion", "CLanguage");
            $this->_someControllers = array("CCsvsController");
            $this->_sLayout = "backlayout";
        }
        public function index() 
        {
            try {
                $someParts = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);
                $iCodeLang = $someParts[0]['id'];
                $someValues = array(
                    'p_sColumns' => 'p.*, c.name as country_name',
                    "p_sTable" => "(payments p LEFT JOIN countries c ON p.country = c.id)",
                    "p_sWhere" => "c.languages_id = $iCodeLang",
                    'p_sOrder' => 'date_pay desc',
                    'p_sLimit' => $this->_iNumberItemsPerPage);

                $someData = $this->paginate('CPayment', 'index', 'backpayments',$someValues);

                   $oSession = new CAppSession();
                $oSession->__setArray("someToCsv",$someValues);
                
                $sLastInserted = 0;
                if ( isset ($this->_someParameters[0]) )
                    $sLastInserted = $this->_someParameters[0];

                $someColumns = $this->_oPayment->describeColumns('payments',true);
                $this->_oView->add('someColumns',$someColumns);
                $this->_oView->add('someData',$someData);

                $this->_oView->add('sLastInserted',$sLastInserted);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',"Backpayments");
                $this->_oLayout->add('sImageMenu',"global/submenu/backpaymentsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(1, __("Backpayments" , $this->_sLanguage , true) , 'backpayments', "index");
             }
             catch(CException $e) {
                throw $e;
             }

        }

        public function edit($iId = null) 
        {
            try {
                if($iId != null)
                {
                    if(isset($this->_someParameters['data']))
                    {
                        $sWhere = 'id = '.$iId;

                        if($this->_oPayment->update($this->_someParameters['data'],$sWhere,false) == C_WARNING_UPDATEDOK)
                        {
                             //First we have to call the index View to create variables that will be used in the View
                            $this->index();

                            //Second we have to set the view that will show the controller
                            $this->_oView->set_sView('index.php');

                            $this->_oLayout->add('sTextMessage','Invoice edited');

                            $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                        }
                        else
                        {
                            $this->_oView->add('someData',$this->_someParameters['data']);
                            $this->_oLayout->add('sTextMessage','Invoide NOT edited');
                            $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                        }

                    }
                    else
                    {
                        $sWhere = 'id = '.$iId;

                        $someValues = array(
                            'p_sColumns' => '*',
                            'p_sWhere' => $sWhere);

                        if($this->_oPayment->select($someValues) == C_WARNING_SELECTEDOK)
                        {
                            $someData = $this->_oPayment->get_someData();

                            $someValues['payments'] = $someData[0];

                            $this->_oView->add('someData',$someValues);
                        }
                        else
                        {
                             //First we have to call the index View to create variables that will be used in the View
                            $this->index();

                            //Second we have to set the view that will show the controller
                            $this->_oView->set_sView('index.php');

                            $this->_oLayout->add('sTextMessage','Invoice not found');

                            $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                        }

                    }

                    $this->_oView->add('iId',$iId);

                }
                else
                {
                     //First we have to call the index View to create variables that will be used in the View
                    $this->index();

                    //Second we have to set the view that will show the controller
                    $this->_oView->set_sView('index.php');

                    $this->_oLayout->add('sTextMessage','Missing id');
                    $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                }
                
                   $iLanguageId = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);
                $iLanguageId = $iLanguageId[0]["id"];
                
                $someCountries = $this->_oCountrie->get_someCountries($iLanguageId);
                $someRegions = $this->_oRegion->get_someRegions(C_COUNTRY_DEFAULT, $iLanguageId);
                $someCities = $this->_oCitie->get_someCities(C_REGION_DEFAULT, $iLanguageId);
                $someLanguages = $this->_oLanguage->getSomeLanguages();
                $someClients = $this->_oUser->get_someProfUsers();
                
                 $this->_oView->add('someCountries', $someCountries);
                $this->_oView->add('someLanguages', $someLanguages);
                $this->_oView->add('someRegions',  $someRegions);
                $this->_oView->add('someCities', $someCities);
                $this->_oView->add("someClients", $someClients);
                
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',__("Invoice edited" , $this->_sLanguage , true));
                $this->_oLayout->add('sImageMenu',"global/submenu/backpaymentsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(2, __("Edit Invoice" , $this->_sLanguage , true) , 'backpayments', "edit/$iId");
           }
           catch(CException $e) {
                throw $e;
           }

        }

        public function add() 
        {
            try {
                $oSession = new CAppSession();
                if(isset($this->_someParameters['data']))
                {
                    if($this->_oPayment->insert( $this->_someParameters['data'] ) == C_WARNING_INSERTEDOK)
                    {
                        //send notification to client
                        $someProfiles = $oSession->__get("someProfile");
                        if (($someProfiles[0]["enabledcollaborative"] == C_PROFILE_COLLABORATIVE_ON) && ($someProfiles[0]["id"] ==  C_PROFILE_ROOT))
                        {
                          
                            //SEND                            
                            $oTimeLineController = $this->getUsedClass("CTimelinesController");
                            $iResult = $oTimeLineController->sendRequest(C_TIMELINE_SEND_INVOICE, $oSession->__get("idadmin"), C_ROOT_ADMIN, 
                            buildEndMessage($this->_someParameters["data"]["payments"]["users_id"], $this->_someParameters["data"]["payments"]["name"])
                                        );
                          

                        }
                        
                        
                         //First we have to call the index View to create variables that will be used in the View
                        $this->index();

                        //Second we have to set the view that will show the controller
                        $this->_oView->set_sView('index.php');
                        $this->_oView->add('sLastInserted' , $this->_oPayment->get_iIdLastInserted() );
                        $this->_oLayout->add('sTextMessage','New Invoice inserted');
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                    }
                    else
                    {
                        $this->_oView->add('someData',$this->_someParameters['data']);
                        $this->_oLayout->add('sTextMessage','New Invoice NOT inserted');
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                    }
                }
                
                $iLanguageId = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);
                $iLanguageId = $iLanguageId[0]["id"];
                
                $someCountries = $this->_oCountrie->get_someCountries($iLanguageId);
                $someRegions = $this->_oRegion->get_someRegions(C_COUNTRY_DEFAULT, $iLanguageId);
                $someCities = $this->_oCitie->get_someCities(C_REGION_DEFAULT, $iLanguageId);
                $someLanguages = $this->_oLanguage->getSomeLanguages();
                $someClients = $this->_oUser->get_someProfUsers();
                
                 $this->_oView->add('someCountries', $someCountries);
                $this->_oView->add('someLanguages', $someLanguages);
                $this->_oView->add('someRegions',  $someRegions);
                $this->_oView->add('someCities', $someCities);
                $this->_oView->add("someClients", $someClients);
                
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',__("Add Invoice" , $this->_sLanguage , true));
                $this->_oLayout->add('sImageMenu',"global/submenu/backpaymentsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(2, __("Add Invoice" , $this->_sLanguage , true) , 'backpayments', "add");
            }
            catch(CException $e) {
                throw $e;
            }
        }

        public function delete( $p_iId = null ) 
        {
            try {
                 //First we have to call the index View to create variables that will be used in the View
                $this->index();

                //if you want to add extra operations to this method, you will have to do it here
                //first we have to delete
                if ( !is_null($p_iId) ) {

                    $iReturnedValue = $this->_oPayment->delete($this->_oPayment->get_sTable(), 'id = '.$p_iId);
                    //if the delete operation success, we will show a message with 'deleted correctly'
                    if ($iReturnedValue == C_WARNING_DELETEOK) {
                        $this->_oLayout->add('sTextMessage', __("Operation executed successfully",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                    }
                    else {
                        $this->_oLayout->add('sTextMessage', __("Operation NOT executed successffuly",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                    }

                }
                //if you want to add extra operations to this method, you will have to do it here

                $this->_oView->set_sView('index.php');
             }
             catch(CException $e) {
                throw $e;
             }
        }

        public function search() 
        {
            try {
                
                $someParts = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);                
                $iCodeLang = $someParts[0]['id'];
                
                $someParameters = $this->get_someParameters();
                if (isset($someParameters) && isset($someParameters['data'])) {
                      $sText = $someParameters['nameIptSearchValue'];
                      $sField = $someParameters['data']['search']['field'];
                      $sTextUpper = strtoupper(utf8_decode($sText));
                      $sTextLower = strtolower(utf8_decode($sText));
                      
                      $someValues = array(
                            'p_sColumns' => 'p.*, c.name as country_name',
                            "p_sTable" => "(payments p LEFT JOIN countries c ON p.country = c.id)",
                            'p_sWhere' => "(".$sField.' LIKE "'.$sText.'" OR '.$sField.' LIKE "'.$sTextLower.'" OR '.$sField.' LIKE "'.$sTextUpper.'"'.") AND c.languages_id = ".$iCodeLang,
                            'p_sLimit' => '30');
                      
                      $someData = $this->paginate('CPayment', 'index', 'backpayments',$someValues);

                       $oSession = new CAppSession();
                      $oSession->__setArray("someToCsv",$someValues);
                      
                      $someColumns = $this->_oPayment->describeColumns('payments',true);
                      $this->_oView->add('someColumns',$someColumns);
                      $this->_oView->add('someData',$someData);
                      $this->_oView->set_sView('index.php');
                }
                $this->_oView->add('sLastInserted',0);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_FULL_GREEN);
                $this->_oLayout->add('sTitleMenu',"Backpayments");
                $this->_oLayout->add('sImageMenu',"global/backpaymentsicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(1, __("Backpayments" , $this->_sLanguage , true) , 'backpayments', "index");
            }
            catch(CException $e) {
                throw $e;
            }
        }
        
        /**
        * This function creates a csv file
        */
        public function exportcsv()
        {
            try
            {
                $oSession = new CAppSession();                
                $someToCsv = $oSession->__getArray("someToCsv");
                $this->_sLayout = 'ajax';
                if ($someToCsv != false)
                {
                    $someToCsv["p_sLimit"] = "";
                    $this->_oUser->select($someToCsv);
                    $someData = $this->_oUser->get_someData();
                    $sFileName = $this->_oCsvsController->export($someData, "backpayments");
                    
                    $this->_oView->add("sPathCsv",C_ROOT.DIRECTORY_SEPARATOR."app".DIRECTORY_SEPARATOR."uploads".DIRECTORY_SEPARATOR."csv".DIRECTORY_SEPARATOR);
                    $this->_oView->add("sFileName",$sFileName);
                }
                else
                {
                    redirect($this->link("index","backpayments"),__("There aren't data to build the csv file",$this->_sLanguage,true),C_MESSAGE_ERROR); die();
                }
                    
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
        public function printpayment($p_iIdPayment)
        {
            try
            {
                $oSession = new CAppSession();
                $iIdAdmin = $oSession->__get("idadmin");
                //first get profile
                $someProfile = $oSession->__get("someProfile"); 
                $somePayments = array();
                if ($someProfile[0]["id"] == C_PROFILE_ROOT)
                {
                   $somePayments = $this->_oPayment->getPaymentById($p_iIdPayment);
                }
                else 
                {
                   $somePayments = $this->_oPayment->getPaymentByIdAndAdmin($p_iIdPayment, $iIdAdmin);
                }
                
                if (count($somePayments)>0)
                {
                    $this->_sLayout = "print";
                    $this->someCss[] = "print.css";
                     //language
                    $oSession = new CAppSession();
                    $iLanguageId = $oSession->__get("iLanguageId");           
                    $sLanguageCode = $this->_oUser->getLanguageCodeByLanguageId($iLanguageId);
                    $iIdUser = $somePayments[0]["users_id"];
                    $someUsers = $this->_oUser->get_someUsersById($iIdUser);
                    $sExpirationDate = $someUsers[0]["expiration_date"];

                    //City and Country
                    $someCountries = $this->_oCountrie->get_internationalCodeLang($somePayments[0]["country"], $iLanguageId);
                    $someCities = $this->_oCitie->get_someCitieDataById( $somePayments[0]["city"], $iLanguageId);

                    $this->_oView->add("sCity",$someCities[0]["name"]);
                    $this->_oView->add("sCountry",$someCountries[0]["name"]);
                    $this->_oView->add('sLanguage',$sLanguageCode[0]["code"]);
                    $this->_oView->add("somePayment",$somePayments);
                    $this->_oView->add("sExpirationDate",$sExpirationDate);
                    
                }
                else
                {
                   redirect($this->link("index","backpayments"),__("There aren't data to build the invoice",$this->_sLanguage,true),C_MESSAGE_ERROR,true); die(); 
                }
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
        
    }
?>