<?php /**
     * Short description of class CUsersController
     *
     * @access private
     
     */

     class CBackusersController extends CAppController {
         
        private $_iNumberItemsPerPage = 100; 
        

        public function CBackusersController(){
            parent::CAppController();
            $this->setType( C_BACKEND );
            $this->_someModels = array("CUser","CCountrie", "CRegion", "CCitie", "CLanguage");
            $this->_someControllers = array("CCsvsController");
            $this->_sLayout = "backlayout";
            $this->someCss[] = "backusers.css";
            $this->_oLayout->add('someCss',$this->someCss);
        }
        public function index() {
            try {
                
                $someParts = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);
                
                $iCodeLang = $someParts[0]['id'];
                
                $oSession = new CAppSession();
                //it gets the profile to be evaluated
                $someProfile = $oSession->__get("someProfile"); 
                $iAdminId = $oSession->__get("idadmin");
                if ($someProfile[0]["id"] == C_PROFILE_ROOT) //only for roots
                {
                
                    $someValues = array(
                        'p_sColumns' => 'u.*, c.name as country',
                        "p_sTable" => "users u LEFT JOIN countries c ON u.countries_id = c.id",
                        "p_sWhere" => "u.type = ".C_PROF_USER." and u.parent_users_id = -1 AND c.languages_id = $iCodeLang",
                        'p_sOrder' => 'u.expiration_date asc',
                        'p_sLimit' => $this->_iNumberItemsPerPage);
                }
                else
                {
                    $someValues = array(
                        'p_sColumns' => 'u.*, c.name as country',
                        "p_sTable" => "users u LEFT JOIN countries c ON u.countries_id = c.id",
                        "p_sWhere" => "(u.id IN (SELECT au.users_id FROM admins_users as au WHERE au.admins_id = $iAdminId)) AND (u.type = ".C_PROF_USER." and u.parent_users_id = -1 AND c.languages_id = $iCodeLang)",
                        'p_sOrder' => 'u.expiration_date asc',
                        'p_sLimit' => $this->_iNumberItemsPerPage);
                }
                
                
                $oSession->__setArray("someToCsv",$someValues);

                $someData = $this->paginate('CUser', 'index', 'backusers',$someValues);

                $sLastInserted = 0;
                if ( isset ($this->_someParameters[0]) )
                    $sLastInserted = $this->_someParameters[0];

                $someColumns = $this->_oUser->describeColumns('users',true);
                $this->_oView->add('someColumns',$someColumns);
                $this->_oView->add('someData',$someData);

                //$this->_oView->add('sLastInserted',$sLastInserted);
                
                //Do Global configurations
                $this->doGlobalConfiguration( array(
                    "p_iMenu" => C_HEADER_MENU_TYPE_SIMPLE_GREEN,
                    "p_sTitleMenu" => "Clients",
                    "p_sImageMenu" => "global/submenu/centericon.png",
                    "p_sButton" => C_HEADER_MAIN_MENU_DASHBOARD,
                    "p_iLevel" => 0,
                    "p_iName" => "Clients",
                    "p_sController" => "backusers",
                    "p_sMethod" => "index"
                ) );
                
             }
             catch(CException $e) {
                throw $e;
             }

        }

        public function edit($iId = null) {
            try {
                if($iId != null)
                {
                    if(isset($this->_someParameters['data']))
                    {
                        $sWhere = 'id = '.$iId;

                        if($this->_oUser->update($this->_someParameters['data'],$sWhere,false) == C_WARNING_UPDATEDOK)
                        {
                             $this->actionDone(__("Client saved correctly", $this->_sLanguage , true));                            
                        }
                        else
                        {                            
                            $this->actionFailed(__("Client NOT saved correctly", $this->_sLanguage , true));
                        }

                    }
                    else
                    {
                        $sWhere = 'id = '.$iId;

                        $someValues = array(
                            'p_sColumns' => '*',
                            'p_sWhere' => $sWhere);

                        if($this->_oUser->select($someValues) == C_WARNING_SELECTEDOK)
                        {
                            $someData = $this->_oUser->get_someData();

                            $someValues['backusers'] = $someData[0];

                            $this->_oView->add('someData',$someValues);
                        }
                        else
                        {
                             //First we have to call the index View to create variables that will be used in the View
                            $this->index();

                            //Second we have to set the view that will show the controller
                            $this->_oView->set_sView('index.php');

                            $this->_oLayout->add('sTextMessage','User not found');

                            $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                        }

                    }

                    $this->_oView->add('iId',$iId);

                }
                else
                {
                     //First we have to call the index View to create variables that will be used in the View
                    $this->index();

                    //Second we have to set the view that will show the controller
                    $this->_oView->set_sView('index.php');

                    $this->_oLayout->add('sTextMessage','Missing id');
                    $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                }
                
               $iLanguageId = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);
                $iLanguageId = $iLanguageId[0]["id"];
                
                $someCountries = $this->_oCountrie->get_someCountries($iLanguageId);
                $someRegions = $this->_oRegion->get_someRegions(C_COUNTRY_DEFAULT, $iLanguageId);
                $someCities = $this->_oCitie->get_someCities(C_REGION_DEFAULT, $iLanguageId);
                $someLanguages = $this->_oLanguage->getSomeLanguages();
                
                 $this->_oView->add('someCountries', $someCountries);
                $this->_oView->add('someLanguages', $someLanguages);
                $this->_oView->add('someRegions',  $someRegions);
                $this->_oView->add('someCities', $someCities);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',__("Edit User" , $this->_sLanguage , true));
                $this->_oLayout->add('sImageMenu',"global/submenu/backusersicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(2, __("Edit User" , $this->_sLanguage , true) , 'backusers', "edit/$iId");
           }
           catch(CException $e) {
                throw $e;
           }

        }

        public function add() {
            try {
                $oSession = new CAppSession();
                $someProfiles = $oSession->__get("someProfile");
                if(isset($this->_someParameters['data']))
                {
                    $this->_someParameters["data"]["users"]["type"] = C_PROF_USER;     
                    $this->_someParameters["data"]["users"]["password"] = md5($this->_someParameters["data"]["users"]["password"]);
                    
                    //COLLABORATIVE
                    if (($someProfiles[0]["enabledcollaborative"] == C_PROFILE_COLLABORATIVE_ON) && ($someProfiles[0]["id"] !=  C_PROFILE_ROOT))
                    {
                        $this->_someParameters["data"]["users"]["deleted"] = 1;
                        //inserts and send notification to admin
                        $this->_oUser->startTransaction();
                        $iResult = $this->_oUser->insert( $this->_someParameters['data'] );
                        $iIdClientCreated = $this->_oUser->get_iIdLastInserted();
                        if ($iResult == C_WARNING_INSERTEDOK)
                        {
                            //SEND
                            $oTimeLineController = $this->getUsedClass("CTimelinesController");
                            $iResult = $oTimeLineController->sendRequest(C_TIMELINE_CREATE_USER, $oSession->__get("idadmin"), C_ROOT_ADMIN, 
                            buildEndMessage($iIdClientCreated, $this->_someParameters["data"]["users"]["name"])
                                    );
                            if ($iResult == C_WARNING_INSERTEDOK)
                            {
                                $this->_oUser->endTransaction();
                            }
                            else
                            {
                                $this->_oUser->rollBackTransaction();
                            }
                        }
                        else
                        {
                            $this->_oUser->rollBackTransaction();
                        }
                        
                    }
                    else
                    {
                        $iResult = $this->_oUser->insert( $this->_someParameters['data'] );
                    }
                    //////
                    
                    
                    
                    if($iResult == C_WARNING_INSERTEDOK)
                    {
                         //First we have to call the index View to create variables that will be used in the View
                        $this->index();

                        //Second we have to set the view that will show the controller
                        $this->_oView->set_sView('index.php');
                        $this->_oView->add('sLastInserted' , $this->_oUser->get_iIdLastInserted() );
                        $this->_oLayout->add('sTextMessage','New User inserted');
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                    }
                    else
                    {
                        $this->_oView->add('someData',$this->_someParameters['data']);
                        $this->_oLayout->add('sTextMessage','New User NOT inserted');
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                    }
                }
                
                $iLanguageId = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);
                $iLanguageId = $iLanguageId[0]["id"];
                
                $someCountries = $this->_oCountrie->get_someCountries($iLanguageId);
                $someRegions = $this->_oRegion->get_someRegions(C_COUNTRY_DEFAULT, $iLanguageId);
                $someCities = $this->_oCitie->get_someCities(C_REGION_DEFAULT, $iLanguageId);
                $someLanguages = $this->_oLanguage->getSomeLanguages();
                
                
                
                $this->_oView->add("isCollaborative",$someProfiles[0]["enabledcollaborative"]);
                $this->_oView->add("profileType",$someProfiles[0]["id"]);
                $this->_oView->add('someCountries', $someCountries);
                $this->_oView->add('someLanguages', $someLanguages);
                $this->_oView->add('someRegions',  $someRegions);
                $this->_oView->add('someCities', $someCities);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',__("Add User" , $this->_sLanguage , true));
                $this->_oLayout->add('sImageMenu',"global/submenu/backusersicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(2, __("Add User" , $this->_sLanguage , true) , 'backusers', "add");
            }
            catch(CException $e) {
                $this->_oUser->rollBackTransaction();
                throw $e;
            }
         }

        public function delete( $p_iId = null, $p_bRequest = 0 ) {
            try {
                 //First we have to call the index View to create variables that will be used in the View
                $this->index();
                $oSession = new CAppSession();
                //if you want to add extra operations to this method, you will have to do it here
                //first we have to delete
                if ( !is_null($p_iId) ) {
                    
                    if ($p_bRequest == 0)
                    {
                        $iReturnedValue = $this->_oUser->delete($this->_oUser->get_sTable(), 'id = '.$p_iId);
                    }
                    else
                    {
                        $someUser = $this->_oUser->get_someUsersByIdWithoutDelete($p_iId);
                        //SEND request
                        $oTimeLineController = $this->getUsedClass("CTimelinesController");
                        $iReturnedValue = $oTimeLineController->sendRequest(C_TIMELINE_DELETE_USER, $oSession->__get("idadmin"), C_ROOT_ADMIN, 
                            buildEndMessage($someUser[0]["id"], $someUser[0]["name"]));
                        $iReturnedValue=C_WARNING_DELETEOK;
                    }
                    //if the delete operation success, we will show a message with 'deleted correctly'
                    if ($iReturnedValue == C_WARNING_DELETEOK) {
                        $this->_oLayout->add('sTextMessage', __("Operation executed successfully",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                    }
                    else {
                        $this->_oLayout->add('sTextMessage', __("Operation NOT executed successffuly",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                    }

                }
                //if you want to add extra operations to this method, you will have to do it here

                $this->_oView->set_sView('index.php');
             }
             catch(CException $e) {
                throw $e;
             }
        }

        public function search() {
            try {
                $someParameters = $this->get_someParameters();
                
                $someParts = $this->_oUser->getLanguageIdByLanguageCode($this->_sLanguage);                
                $iCodeLang = $someParts[0]['id'];
                
                if (isset($someParameters) && isset($someParameters['data'])) {
                      $sText = $someParameters['nameIptSearchValue'];
                      $sField = $someParameters['data']['search']['field'];
                      $sTextUpper = strtoupper(utf8_decode($sText));
                      $sTextLower = strtolower(utf8_decode($sText));
                      
                      $oSession = new CAppSession();
                      //it gets the profile to be evaluated
                      $someProfile = $oSession->__get("someProfile"); 
                      $iAdminId = $oSession->__get("idadmin");
                      if ($someProfile[0]["id"] == C_PROFILE_ROOT) //only for roots
                      {
                      
                        $someValues = array(
                            'p_sColumns' => 'u.*, c.name as country',
                            "p_sTable" => "users u LEFT JOIN countries c ON u.countries_id = c.id",
                            'p_sWhere' => "(u.type = ".C_PROF_USER." and u.parent_users_id = -1 AND c.languages_id = $iCodeLang) AND (".
                                            $sField.' LIKE "%'.$sText.'%" OR '.$sField.' LIKE "%'.$sTextLower.'%" OR '.$sField.' LIKE "%'.$sTextUpper.'%")',
                            'p_sLimit' => $this->_iNumberItemsPerPage);
                      }
                      else
                      {
                          $someValues = array(
                            'p_sColumns' => 'u.*, c.name as country',
                            "p_sTable" => "users u LEFT JOIN countries c ON u.countries_id = c.id",
                            'p_sWhere' => "(u.id IN (SELECT au.users_id FROM admins_users as au WHERE au.admins_id = $iAdminId)) 
                              AND (u.type = ".C_PROF_USER." and u.parent_users_id = -1 AND c.languages_id = $iCodeLang) AND (".
                                            $sField.' LIKE "%'.$sText.'%" OR '.$sField.' LIKE "%'.$sTextLower.'%" OR '.$sField.' LIKE "%'.$sTextUpper.'%")',
                            'p_sLimit' => $this->_iNumberItemsPerPage);
                      }
                      
                      $someData = $this->paginate('CUser', 'index', 'backusers',$someValues);
                                            
                      $oSession->__setArray("someToCsv",$someValues);

                      $someColumns = $this->_oUser->describeColumns('users',true);
                      $this->_oView->add('someColumns',$someColumns);
                      $this->_oView->add('someData',$someData);
                      $this->_oView->set_sView('index.php');
                }
                $this->_oView->add('sLastInserted',0);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_FULL_GREEN);
                $this->_oLayout->add('sTitleMenu',"Backusers");
                $this->_oLayout->add('sImageMenu',"global/backusersicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(1, __("Backusers" , $this->_sLanguage , true) , 'backusers', "index");
            }
            catch(CException $e) {
                throw $e;
            }
        }
        
        /**
         * This function changes the state of a client. If the client is activated it will be deactivated else it will be activated
         * @param type $p_iId the identifier of the client that will be activated or deactivated
         * 
         */
        public function changestate($p_iId, $p_bRequest = 0)
        {
            try
            {
                //it gets the user. In this case it will not use the column deleted
                $someUsers = $this->_oUser->get_someUsersByIdWithDeletedOn($p_iId);
                $oSession = new CAppSession();
                //it will update the table users and apikeys
                if (count($someUsers)>0)
                {
                    if ($p_bRequest == 0)
                    {
                        $iState = C_USER_ACTIVATE;
                        if ($someUsers[0]["deleted"] == C_USER_ACTIVATE)
                        {
                            $iState = C_USER_DEACTIVATE;
                        }
                        else
                        {
                            $iState = C_USER_ACTIVATE;
                        }

                        $bReturnValue = $this->_oUser->activateDeactivate($p_iId,$iState);
                    }
                    else
                    {
                        $iAction = C_TIMELINE_DEACTIVATE_USER;
                        if ($someUsers[0]["deleted"] == C_USER_ACTIVATE)
                        {
                            $iAction = C_TIMELINE_DEACTIVATE_USER;
                        }
                        else
                        {
                            $iAction = C_TIMELINE_ACTIVATE_USER;
                        }
                        
                        
                        $someUser = $this->_oUser->get_someUsersByIdWithoutDelete($p_iId);
                        //SEND request
                        $oTimeLineController = $this->getUsedClass("CTimelinesController");
                        $iReturnedValue = $oTimeLineController->sendRequest($iAction, $oSession->__get("idadmin"), C_ROOT_ADMIN, 
                            buildEndMessage($someUser[0]["id"], $someUser[0]["name"]));
                        $bReturnValue=true;                     
                        
                    }
                    if ($bReturnValue == true)                        
                    {
                        
                        redirect($this->link("index","backusers"),__("The state of the client was saved correctly",$this->_sLanguage,true),C_MESSAGE_OK, true); die();
                    }
                    else
                    {
                        redirect($this->link("index","backusers"),__("The state of the client wasn't saved",$this->_sLanguage,true),C_MESSAGE_ERROR); die();
                    }
                }
                
                
                
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
        /**
         * This function creates a csv file
         */
        public function exportcsv()
        {
            try
            {
                $oSession = new CAppSession();                
                $someToCsv = $oSession->__getArray("someToCsv");
                $this->_sLayout = 'ajax';
                if ($someToCsv != false)
                {
                    $someToCsv["p_sLimit"] = "";
                    $this->_oUser->select($someToCsv);
                    $someData = $this->_oUser->get_someData();
                    $sFileName = $this->_oCsvsController->export($someData, "backusers");
                    
                    $this->_oView->add("sPathCsv",C_ROOT.DIRECTORY_SEPARATOR."app".DIRECTORY_SEPARATOR."uploads".DIRECTORY_SEPARATOR."csv".DIRECTORY_SEPARATOR);
                    $this->_oView->add("sFileName",$sFileName);
                }
                else
                {
                    redirect($this->link("index","backusers"),__("There aren't data to build the csv file",$this->_sLanguage,true),C_MESSAGE_ERROR); die();
                }
                
                    
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
        public function accessaccount($p_iIdUser)
        {
            try
            {                
                //first it will check if a user admin has access to log into a user account
                $oSession = new CAppSession();                   
                $someProfile = $oSession->__get("someProfile");
                $someUsers = $this->_oUser->getSomeUsersByProfile($someProfile[0]["id"],$oSession->__get("idadmin"),$p_iIdUser);
                if (count($someUsers)<=0)
                {
                    redirect($this->link("index","backusers"),__("You can't access to this user",$this->_sLanguage,true),C_MESSAGE_ERROR); 
                    die();
                }
                else
                {
                    //access to the account and redirect
                    $oSession->__set("id",$someUsers[0]['id']);
                    $oSession->__set("login",$someUsers[0]['email']);
                    $oSession->__set("type",C_PROF_USER); //0 it's the PROFESSIONAL user
                    $oSession->__set("name",$someUsers[0]["name"]);
                    $oSession->__set("logo",$someUsers[0]["logo"]);
                    $oSession->__set("url",$someUsers[0]["url"]);
                    $oSession->__set("firsttimevalidation",1);                    
                    $sLanguageCode = $this->_oUser->getLanguageCodeByLanguageId($someUsers[0]['languages_id']);
                    $oSession->__set("userproflanguage",$sLanguageCode[0]["code"]);
                }
                
                redirect($this->link("index","dashboard"),"","",true);
                die();
                
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
    }
?>