<?php
    /*
     * Short description of class CUsersController
     *
     * @access private
     * @author NUBESIS, <info@nubesis.com>
     */

     class CBanksController extends CAppController {

        public function CBanksController(){
            parent::CAppController();
            $this->setType( C_FRONTEND );
            $this->_someModels = array('CBank',"CUser");
            $this->_someControllers = array("CConfigurationsController");
            
        }

        public function index() {
            try {
                
                $oSession = new CAppSession();
                $iIdUser = $oSession->__get("id");
                if( !$this->validateUsersID( $iIdUser  ) )
                { redirect( $this->link ("index", "dashboard" ) , __("You don't have Permissions to do this action",$this->_sLanguage,true) , C_MESSAGE_ERROR , true );die (); }

                $this->someCss[] = "mycenter.css";
//                $this->someJavascripts[] = 'mycenter.js';

                $iUserID = $this->getUsersID();
                $iUserParentId = $this->_oUser->get_firstParentIdByUserId($iUserID);

                if(isset($this->_someParameters['data']))
                { //it's doing a submit

                    if( !$this->checkUserCanEditBanks() )
                    { redirect( $this->link ("index", "dashboard" ) , __("You don't have Permissions to do this action", $this->_sLanguage , true) , C_MESSAGE_ERROR , true );die (); }

                    //first it will sabe the prefix
                    $this->_oBank->startTransaction();
                    $iReturnValue = $this->_oUser->updatePrefReference($iUserParentId,$this->_someParameters["data"]["banks"]["prefreference"]);
                    if ($iReturnValue == C_WARNING_UPDATEDOK)
                    {
                        $iReturnValue = $this->_oBank->updateBanks($this->_someParameters["data"]["banks"],$iUserParentId);
                        if ($iReturnValue == C_WARNING_UPDATEDOK) {
                            //redirect ok
                            $this->_oBank->endTransaction();
                            $this->actionDone(__("Banks Edited Correctly", $this->_sLanguage , true));
                        }
                        else {
                            $this->_oBank->rollBackTransaction();
                            $this->actionFailed(__("Banks NOT edited", $this->_sLanguage , true));
                        }
                    }  
                    else
                    {
                        $this->_oBank->rollBackTransaction();
                        $this->actionFailed(__("Banks NOT edited", $this->_sLanguage , true));
                    }
                }
                else {
                    $sPrefReference = $this->_oUser->getPrefReference($iUserParentId);
                    $someValues["banks"]["prefreference"] = $sPrefReference;

                    $someBanks = $this->_oBank->getSomeBanksByUserId($iUserParentId);
                    for($i=0;$i<count($someBanks);$i++) {
                        $someValues["banks"][$someBanks[$i]["id"]]["selected"] = true;
                        $someValues["banks"][$someBanks[$i]["id"]]["store_code"] = $someBanks[$i]["store_code"];
                        $someValues["banks"][$someBanks[$i]["id"]]["paypal_email"] = $someBanks[$i]["paypal_email"];
                        $someValues["banks"][$someBanks[$i]["id"]]["paypal_url_return"] = $someBanks[$i]["paypal_url_return"];
                        $someValues["banks"][$someBanks[$i]["id"]]["paypal_prodsim"] = $someBanks[$i]["paypal_prodsim"];
                        
                    }                   
                    
                    $this->_someParameters['data'] = $someValues;
                }

                $sWidgetCodes = $this->_oConfigurationsController->getApiKeys($iUserParentId);

                $this->_oView->add("sWidgetCodes",$sWidgetCodes);
                

                 //Do Global configurations
                $this->doGlobalConfiguration( array(
                    "p_iMenu" => C_HEADER_MENU_TYPE_SIMPLE_GREY,
                    "p_sTitleMenu" => "Payment Gateway",
                    "p_sImageMenu" => "global/submenu/payicon.png",
                    "p_sButton" => C_HEADER_MAIN_MENU_DASHBOARD,
                    "p_iLevel" => 1,
                    "p_iName" => "Payment Gateway",
                    "p_sController" => "banks",
                    "p_sMethod" => "index"
                ) );

                
              

            }
            catch(CException $e) {
             //   $this->_oBank->rollBackTransaction();
                throw $e;
            }
        }

        protected function checkUserCanEditBanks(){
            try{
                $iUserID = $this->getUsersID();
                $iUserParentId = $this->_oUser->get_firstParentIdByUserId($iUserID);

                if($iUserParentId == $iUserID){
                    return true;
                }

                $someUserAccess = array();

                if (__isPluginInstalled(C_PLUGINS."profiles/")) {
                    $oProfilesController = $this->getUsedClass("CProfilesController");
                    $someUserAccess = $oProfilesController->validateUserAccess($iUserID);
                }

                if(isset ($someUserAccess["banks"]["edit"]) && $someUserAccess["banks"]["edit"] == 3){
                    return true;
                }
                else{
                    return false;
                }
            }
            catch(CException $e) {
                throw $e;
            }
        }
        

     }

?>
