<?php /**
     * Short description of class CTimelinesController
     *
     * @access private
     * @author NUBESIS, <info@nubesis.com>
     */

     class CTimelinesController extends CAppController {

        private $_iNumberItemsPerPage = 100;   
         
        public function CTimelinesController(){
            parent::CAppController();
            $this->setType( C_BACKEND );
            $this->_sLayout = "backlayout";
            $this->_someModels = array("CTimeline","CUser","CCountrie", "CRegion", "CCitie", "CLanguage", "CAdmin");
            
            
        }
        public function index() {
            try {
                
                $oSession = new CAppSession();
                
                $someProfile = $oSession->__get("someProfile");
                
                
                if ($someProfile[0]["id"] == C_PROFILE_ROOT) //only for roots
                {
                    $someValues = array(
                    'p_sColumns' => '*',
                    'p_sOrder' => 'id desc',
                    "p_sWhere" => "admins_target_id = ".$oSession->__get("idadmin"),
                    'p_sLimit' => $this->_iNumberItemsPerPage);
                }
                elseif($someProfile[0]["id"] == C_PROFILE_CLIENT)
                {
                    $someValues = array(
                    'p_sColumns' => '*',
                    'p_sOrder' => 'id desc',
                    "p_sWhere" => "action =".C_TIMELINE_SEND_INVOICE,
                    'p_sLimit' => $this->_iNumberItemsPerPage);
                }
                else
                {
                    $someValues = array(
                    'p_sColumns' => '*',
                    'p_sOrder' => 'id desc',
                    "p_sWhere" => "admins_target_id = ".$oSession->__get("idadmin")." OR admins_source_id = ".$oSession->__get("idadmin"),
                    'p_sLimit' => $this->_iNumberItemsPerPage);
                }

                $someData = $this->paginate('CTimeline', 'index', 'timelines',$someValues);

                $sLastInserted = 0;
                if ( isset ($this->_someParameters[0]) )
                    $sLastInserted = $this->_someParameters[0];

                $someColumns = $this->_oTimeline->describeColumns('timelines',true);
                $this->_oView->add('someColumns',$someColumns);
                
                
                $oSession->__setArray("someToCsv",$someValues);
                
                for($i=0;$i<count($someData);$i++)
                {
                    $someData[$i]["text"] = $this->_oTimeline->getTextForTimeLine($someData[$i]["id"],$oSession->__get("idadmin")).$someData[$i]["text"];
                }
                
                $this->_oView->add('someData',$someData);

                $this->_oView->add('sLastInserted',$sLastInserted);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_SIMPLE_GREEN);
                $this->_oLayout->add('sTitleMenu',"Timelines");
                $this->_oLayout->add('sImageMenu',"global/submenu/timelinesicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(1, __("Timelines" , $this->_sLanguage , true) , 'timelines', "index");
             }
             catch(CException $e) {
                throw $e;
             }

        }

      

        public function search() {
            try {
                $someParameters = $this->get_someParameters();
                if (isset($someParameters) && isset($someParameters['data'])) {
                      $sText = $someParameters['nameIptSearchValue'];
                      $sField = $someParameters['data']['search']['field'];
                      $sTextUpper = strtoupper(utf8_decode($sText));
                      $sTextLower = strtolower(utf8_decode($sText));

                      $someValues = array(
                            'p_sColumns' => '*',
                            'p_sWhere' => $sField.' LIKE "'.$sText.'" OR '.$sField.' LIKE "'.$sTextLower.'" OR '.$sField.' LIKE "'.$sTextUpper.'"',
                            'p_sLimit' => $this->_iNumberItemsPerPage);
                      $someData = $this->paginate('CTimeline', 'index', 'timelines',$someValues);

                      $someColumns = $this->_oTimeline->describeColumns('timelines',true);
                      $this->_oView->add('someColumns',$someColumns);
                      $this->_oView->add('someData',$someData);
                      $this->_oView->set_sView('index.php');
                }
                $this->_oView->add('sLastInserted',0);
                $this->_oLayout->add('iMenu',C_HEADER_MENU_TYPE_FULL_GREEN);
                $this->_oLayout->add('sTitleMenu',"Timelines");
                $this->_oLayout->add('sImageMenu',"global/timelinesicon.png");
                $this->_oLayout->add('sButton',C_HEADER_MAIN_MENU_DASHBOARD);
                $this->getComponent('CBreadcrumbComponent')->add(1, __("Timelines" , $this->_sLanguage , true) , 'timelines', "index");
            }
            catch(CException $e) {
                throw $e;
            }
        }
        
        
        public function sendRequest($p_iAction, $p_iIdFrom, $p_iIdTo, $p_sExtra = "")
        {
            try
            {
                $oSession = new CAppSession();
                $iResult = -1;                
                
                
                
                $iResult = $this->_oTimeline->addTimeline($p_sExtra, date("Y-m-d H:i:s"), $p_iIdFrom, $p_iIdTo, $p_iAction, C_TIMELINE_STATE_PENDING);
                if ($iResult == C_WARNING_INSERTEDOK)
                {
                    //SEND AN EMAIL
                    $oAdmin = $this->getUsedClass("CAdmin");
                    $someAdminTo = $oAdmin->getSomeAdminsById($p_iIdTo);
                    
                    $oMessageController = $this->getUsedClass("CMessagesController");
                    $oMessageController->getUsedModels();
                    $oMessageController->saveSystemMessage(
                            array(
                                "p_sMailSource" => $oSession->__get("loginadmin"),
                                "p_sMailTarget" => $someAdminTo[0]["email"],
                                "p_sMessageTitle" => "Collaborative Message",
                                "p_sMessageText" => "$p_sExtra",                                
                                "p_sUsersType" => C_ADMIN_USER
                            )
                    );
                }
                
            }
            catch(CException $e)
            {
                throw $e;
            }
            
            return $iResult;
        }
        
        
        public function sendAnswer($p_iAction, $p_iIdFrom, $p_iIdTo, $p_sExtra="")
        {
            try
            {
                $sMessage = "";
                $oSession = new CAppSession();
                if ($p_iAction == C_TIMELINE_STATE_ACCEPTED)
                {
                    $sMessage = __("Your request has been accepted. ",$this->_sLanguage,true);
                }
                elseif($p_iAction == C_TIMELINE_STATE_REJECTED)
                {
                    $sMessage = __("Your request has been rejected. ",$this->_sLanguage,true);
                }
                
                $sMessage .= $p_sExtra;
                $iResult = $this->_oTimeline->addTimeline($sMessage, date("Y-m-d H:i:s"), $p_iIdFrom, $p_iIdTo, C_TIMELINE_ANSWER, $p_iAction);
                if ($iResult == C_WARNING_INSERTEDOK)
                {
                   //SEND AN EMAIL
                    $oAdmin = $this->getUsedClass("CAdmin");
                    $someAdminTo = $oAdmin->getSomeAdminsById($p_iIdTo);
                    
                    $oMessageController = $this->getUsedClass("CMessagesController");
                    $oMessageController->getUsedModels();
                    $oMessageController->saveSystemMessage(
                            array(
                                "p_sMailSource" => $oSession->__get("loginadmin"),
                                "p_sMailTarget" => $someAdminTo[0]["email"],
                                "p_sMessageTitle" => "Collaborative Message",
                                "p_sMessageText" => "$sMessage",
                                "p_sUsersType" => C_ADMIN_USER
                            )
                    );
                }
                
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
        
        public function accept($p_iIdTimeline)
        {
            try
            {
               $someTimelines = $this->_oTimeline->getTimeLineById($p_iIdTimeline);
                
               if (count($someTimelines)>0)
               {
                   $someToId = explode(":",$someTimelines[0]["text"]);
                   $iIdUser = trim($someToId[2]);
                   $someUser = $this->_oUser->get_someUsersByIdWithoutDelete($iIdUser);
                   if ($someTimelines[0]["action"] == C_TIMELINE_CREATE_USER)
                   {
                       //change deleted to 1 the user and adds to admins_users
                       $this->_oUser->activateDeactivate($iIdUser,0);
                       $this->_oUser->addUserToAdmin($someTimelines[0]["admins_source_id"],$iIdUser);  
                   }
                   elseif ($someTimelines[0]["action"] == C_TIMELINE_MODIFY_USER)
                   {
                       $this->_oUser->activateDeactivate($iIdUser,0);
                   }
                   elseif ($someTimelines[0]["action"] == C_TIMELINE_DELETE_USER)
                   {
                       //change deleted to 1 the user and adds to admins_users
                       $this->_oUser->activateDeactivate($iIdUser,1);
                       $this->_oUser->deleteUserToAdmin($someTimelines[0]["admins_source_id"],$iIdUser);                       
                   }
                   elseif ($someTimelines[0]["action"] == C_TIMELINE_ACTIVATE_USER)
                   {
                       //change deleted to 1 the user and adds to admins_users
                       $this->_oUser->activateDeactivate($iIdUser,0);                       
                   }
                   elseif ($someTimelines[0]["action"] == C_TIMELINE_DEACTIVATE_USER)
                   {
                       $this->_oUser->activateDeactivate($iIdUser,1);                       
                   }
                   elseif ($someTimelines[0]["action"] == C_TIMELINE_SEND_INVOICE)
                   {
                       
                   }
                   
                   //send notification
                   $this->sendAnswer(C_TIMELINE_STATE_ACCEPTED,$someTimelines[0]["admins_target_id"],
                           $someTimelines[0]["admins_source_id"],  buildEndMessage($iIdUser, $someUser[0]["name"]));
                   $this->_oTimeline->changeState($p_iIdTimeline, C_TIMELINE_STATE_ACCEPTED);
               }
               
               redirect($this->link ("index", "timelines" ), __("Action Accepted",$this->_sLanguage,true), C_MESSAGE_OK,true);
               die();
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
        public function reject($p_iIdTimeline)
        {
            try
            {
               $someTimelines = $this->_oTimeline->getTimeLineById($p_iIdTimeline);
               if (count($someTimelines)>0)
               {
                   $someToId = explode(":",$someTimelines[0]["text"]);
                   $iIdUser = trim($someToId[2]);
                   $someUser = $this->_oUser->get_someUsersByIdWithoutDelete($iIdUser);
                   //send notification
                   $this->sendAnswer(C_TIMELINE_STATE_ACCEPTED,$someTimelines[0]["admins_target_id"],
                           $someTimelines[0]["admins_source_id"],  buildEndMessage($iIdUser, $someUser[0]["name"]));
                   $this->_oTimeline->changeState($p_iIdTimeline, C_TIMELINE_STATE_REJECTED);
               }
               redirect($this->link ("index", "timelines" ), __("Action Rejected",$this->_sLanguage,true), C_MESSAGE_ERROR, true);
               die();
            }
            catch(CException $e)
            {
               throw $e;
            }
            
        }
        
        
          public function delete( $p_iId = null) {
            try {
                 //First we have to call the index View to create variables that will be used in the View
                $this->index();
                $oSession = new CAppSession();
                //if you want to add extra operations to this method, you will have to do it here
                //first we have to delete
                if ( !is_null($p_iId) ) {
                    $iReturnedValue = $this->_oUser->delete($this->_oTimeline->get_sTable(), 'id = '.$p_iId);
                 
                    //if the delete operation success, we will show a message with 'deleted correctly'
                    if ($iReturnedValue == C_WARNING_DELETEOK) {
                        $this->_oLayout->add('sTextMessage', __("Operation executed successfully",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_OK);
                    }
                    else {
                        $this->_oLayout->add('sTextMessage', __("Operation NOT executed successffuly",$this->_sLanguage, true));
                        $this->_oLayout->add('sTypeMessage',C_MESSAGE_ERROR);
                    }

                }
                //if you want to add extra operations to this method, you will have to do it here

                $this->_oView->set_sView('index.php');
             }
             catch(CException $e) {
                throw $e;
             }
        }
        
        
        public function chat()
        {
            try
            {
                $this->someCss[] = "chat.css";
                $this->someJavascripts[] = 'chat.js';
                
                
            }
            catch(CException $e)
            {
                throw $e;
            }
                
        }
        
        
        public function addmessage()
        {
            try
            {
                $this->_sLayout = "ajax";
                
                $someParameters = $this->get_someParameters();
                $sText = $someParameters[0];
                
                $oSession = new CAppSession();
                $iIdAdmin = $oSession->__get("idadmin");
                
                
                
                $someToInsert = array();
                $someToInsert["chat"]["text"] = $sText;
                $someToInsert["chat"]["admins_source_id"] = $iIdAdmin;
                $someToInsert["chat"]["deleted"] = 0;
                
                $iResult = $this->_oTimeline->insert($someToInsert,false,false);                
                
                if ($iResult == C_WARNING_INSERTEDOK)
                {
                    $iIdLastInserted = $this->_oTimeline->get_iIdLastInserted();
                    if ($oSession->__get("idLineChat") == false)
                    {
                        $oSession->__set("idLineChat",$iIdLastInserted);
                    }
                }
                
                $this->_oView->add("iReturn",$iResult);
                
                
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
        
        public function getmessages()
        {
            try
            {
                
                $oSession = new CAppSession();
                $this->_sLayout = "ajax";
                $sHtml = "";
                if ($oSession->__get("idLineChat") != false)
                {
                    $this->_oTimeline->select(
                            array(
                              'p_sColumns' => '*',
                              "p_sTable" => "chat",                          
                              "p_sWhere" => "id >= ".$oSession->__get("idLineChat"),

                            )
                    );
                    $someData = $this->_oTimeline->get_someData();
                    $sHtml = "";
                    foreach($someData as $oData)
                    {
                        $someAdmins = $this->_oAdmin->getSomeAdminsById($oData["admins_source_id"]);
                        
                        $sHtml .= "<p>".$someAdmins[0]["company_name"].": ".$oData["text"]."</p>";
                    }
                }
                $this->_oView->add("sHtml",$sHtml);
            }
            catch(CException $e)
            {
                throw $e;
            }
        }
        
    }
?>