<?php
    /**
     * Short description of class CClient
     *
     * @access private
     * @author NUBESIS, <info@nubesis.com>
     */
     class CClient extends CAppModel{
        public function CClient(){
            $this->_sTable = 'clients';

            $this->set_someValidators(
            array(
                    "add" => array(
                        "name" => array(
                            C_VALID_NOT_EMPTY => array(
                                "message" => __("The name can't be empty",$this->_sLanguage, true)
                            )
                        )
                    )
                )
            );
        }

        public function getClientsByUserId( $p_iUser_id ){
            try{
                $someSelectValues = array(
                    "p_sColumns" => 'u.id as users_id, c.id as id, CONCAT(IFNULL(c.email,""), IFNULL(u.email,"")) as email,
                        CONCAT(IFNULL(c.photo,""), IFNULL(u.photo,"")) as photo, c.users_id as users_id, CONCAT(IFNULL(c.name,""),
                        IFNULL(u.name,"")) as name,CONCAT(IFNULL(c.phone,""), IFNULL(u.phone,"")) as phone, CONCAT(IFNULL(c.cellphone,""),
                        IFNULL(u.cellphone,"")) as cellphone, c.description as description, u.document as user_document, c.custom_1 as client_document',
//                    "p_sColumns" => "c.* , u.description as user_description, u.tags as user_tags, u.name as user_name, u.name_tags as user_name_tags, u.description_tags as user_description_tags, u.email as user_email, u.id as user_id, u.phone as user_phone, u.photo as user_photo  ",
                    "p_sTable" => "clients as c left join users as u on u.id = c.users_id",
                    "p_sWhere" => "c.deleted = 0 AND c.banned = 0 AND c.client_of = ".$p_iUser_id
                );

                $this->select($someSelectValues);

                return $this->get_someData();
            }
            catch(CException $e) {
                throw $e;
            }
        }

        public function getClientsByUserIdPopUp( $p_iUser_id , $p_sSearch ){
            try{
                $someSelectValues = array(
                    "p_sColumns" => 'u.id as users_id, c.id as id, CONCAT(IFNULL(c.email,""), IFNULL(u.email,"")) as email,
                        CONCAT(IFNULL(c.photo,""), IFNULL(u.photo,"")) as photo, c.users_id as users_id, CONCAT(IFNULL(c.name,""),
                        IFNULL(u.name,"")) as name,CONCAT(IFNULL(c.phone,""), IFNULL(u.phone,"")) as phone, CONCAT(IFNULL(c.cellphone,""),
                        IFNULL(u.cellphone,"")) as cellphone, c.description as description, u.document as user_document, c.custom_1 as client_document',
//                    "p_sColumns" => "c.* , u.description as user_description, u.tags as user_tags, u.name as user_name, u.name_tags as user_name_tags, u.description_tags as user_description_tags, u.email as user_email, u.id as user_id, u.phone as user_phone, u.photo as user_photo  ",
                    "p_sTable" => "clients as c left join users as u on u.id = c.users_id",
                    "p_sWhere" => "c.deleted = 0 AND c.banned = 0 AND c.client_of = ".$p_iUser_id." AND ( u.document like '%".$p_sSearch."%' OR c.custom_1 like '%".$p_sSearch."%' OR u.name like '%".$p_sSearch."%' OR c.name like '%".$p_sSearch."%' OR u.email like '%".$p_sSearch."%' OR c.email like '%".$p_sSearch."%' OR u.cellphone like '%".$p_sSearch."%' OR c.cellphone like '%".$p_sSearch."%' )",
                    "p_sLimit" => "10"
                );

                $qwe = $this->select($someSelectValues);

                return $this->get_someData();
            }
            catch(CException $e) {
                throw $e;
            }
        }

        public function getClientByIdClient($p_iIdClient) {
            try {
                $someSelectValues = array(
                    "p_sColumns" => "*",
                    "p_sTable" => "clients",
                    "p_sWhere" => "id = ".$p_iIdClient." AND deleted = 0"
                );

                $this->select($someSelectValues);

            }
            catch(CException $e) {
                throw $e;
            }
            return $this->get_someData();
        }

        public function get_someClientsByClientOf($p_iUserId) {
            try {
                $someSelectValues = array(
                    "p_sColumns" => "*",
                    "p_sTable" => "clients",
                    "p_sWhere" => "client_of = ".$p_iUserId." AND deleted = 0"
                );

                $this->select($someSelectValues);

            }
            catch(CException $e) {
                throw $e;
            }
            return $this->get_someData();
        }

        public function getClientIdByUserId($p_iuserId, $p_clientOf) {
            try {
                $someSelectValues = array(
                    "p_sColumns" => "*",
                    "p_sTable" => "clients",
                    "p_sWhere" => "users_id = ".$p_iuserId." AND deleted = 0 AND client_of = $p_clientOf"
                );

                $this->select($someSelectValues);

            }
            catch(CException $e) {
                throw $e;
            }
            return $this->get_someData();
        }

        public function getSomeEventsByClientsID($p_iClientId) {
            try {
                $someSelectValues = array(
                    "p_sColumns" => "*",
                    "p_sTable" => "events_clients",
                    "p_sWhere" => "clients_id = $p_iClientId"
                );
                $this->select($someSelectValues);

            }
            catch(CException $e) {
                throw $e;
            }
            return $this->get_someData();
        }

        public function getoClientsByEventID( $p_iID ){
            try{
                $someSelectValues = array(
                    "p_sColumns" => "c.* , u.description as user_description, u.tags as user_tags, u.name as user_name,
                        u.name_tags as user_name_tags, u.description_tags as user_description_tags,
                        u.email as user_email, u.id as user_id, u.phone as user_phone,
                        u.cellphone as user_cellphone, u.photo as user_photo, u.document as user_document",
                    "p_sTable" => "(events_clients as e
                                    left join clients as c on e.clients_id = c.id)
                                    left join users as u on c.users_id = u.id",
                    "p_sWhere" => "e.events_id = ".$p_iID
                );

                $this->select($someSelectValues);

                return $this->get_someData();
            }
            catch(CException $e) {
                throw $e;
            }
        }

        public function getUserIdByClientId( $p_iClientId )
        {
            $iUserID = 0;
            try{
                if(is_null( $p_iClientId ))
                    return $iUserID;

                $someSelectValues = array(
                    "p_sColumns" => "client_of",
                    "p_sTable" => "clients",
                    "p_sWhere" => "id = ".$p_iClientId." AND deleted = 0"
                );

                $this->select($someSelectValues);

                $someResults = $this->get_someData();

                if( count( $someResults ) > 0 )
                    return $someResults[0]['client_of'];
            }
            catch(CException $e) {
                throw $e;
            }
            return $iUserID;
        }

        public function getClientsReportsByUserID( $p_iUserId )
        {
            $someResults= null;
            
            try{
                $someSelectValues = array(
                    "p_sColumns" => "*",
                    "p_sTable" => "clients",
                    "p_sWhere" => "client_of = ".$p_iUserId." AND deleted = 0"
                );

                $this->select($someSelectValues);

                $someResults = $this->get_someData();

            }
            catch(CException $e) {
                throw $e;
            }
            return $someResults;
        }

        public function getClientsByUserIDPaginate( $p_iUserId )
        {
            $someResults= null;

            try{
                $someSelectValues = array(
                    "p_sColumns" => "*",
                    "p_sTable" => "clients",
                    "p_sWhere" => "client_of = ".$p_iUserId." AND deleted = 0",
                    "p_sLimit" => "5000"
                );
            }
            catch(CException $e) {
                throw $e;
            }
            return $someSelectValues;
        }

        public function getClientsLastMonth( $p_iUserId , $p_sFechaInicio , $p_sFechaFin)
        {
            $someResults= null;

            try{
                $someSelectValues = array(
                    "p_sColumns" => "*",
                    "p_sTable" => "clients",
                    "p_sWhere" => "client_of = ".$p_iUserId." AND deleted = 0 AND created <= '$p_sFechaFin' AND created >= '$p_sFechaInicio'"
                );

                $this->select($someSelectValues);

                $someResults = $this->get_someData();

            }
            catch(CException $e) {
                throw $e;
            }
            return $someResults;
        }


       /**
        * This function validates a user by a custom field. These custome fields are
        * defined by the coder.
        * @param <type> $p_someCustomField array("custom_field_1" => "valuetocompare", "custom_field_2" => "valuetocompare")
        */
        public function validateByCustomField($p_someCustomField) {
            try {
                $sStringCondition = "";
                foreach ($p_someCustomField as $sKey => $sValue)
                {
                    $sStringCondition .= "$sKey LIKE '$sValue' AND ";
                }

                $sStringCondition = substr($sStringCondition, 0,strlen($sStringCondition)-4);

                $iReturnValue = $this->select(
                                                array("p_sColumns" => "*",
                                                      "p_sWhere" => "$sStringCondition AND deleted=0 ",
                                                      "p_sTable" => "clients"
                                                    )
                                            );

                if ($iReturnValue == C_WARNING_SELECTEDOK) {
                    //we get the data of the executed query
                    $someData = $this->get_someData();
                    if (count($someData)>0) {
                        $bReturnValue = $someData[0]["id"];
                        return $bReturnValue;
                    }
                }
            }
            catch(CException $e) {
                throw $e;
            }
            return $bReturnValue = -1;
        }

        /**
         * This function updates the cell phone code
         * @param <type> $p_someUsers the parametters getted from the view, in this case cellphonecode
         * @param <type> $p_iIdUser the identifier of the user that it will update
         * @return <type> if there is error it returns -1, else it returns the id of the user
         */
        public function edit_oClientFromWidgetDtl($p_someUpdate, $p_iIdUser) {
            try
            {                
                
                $iReturnValue = $this->update($p_someUpdate, "id = $p_iIdUser AND deleted = 0");
                if ($iReturnValue == C_WARNING_UPDATEDOK)
                    $iReturnValue = $p_iIdUser;
                else
                    $iReturnValue = -1;

            }
            catch(CException $e) {
                throw $e;
            }

            return $iReturnValue;
        }

        public function get_someClientsByDocument($p_sDocument, $p_iUserId) {
            try {
                $someData = array();

                //we get the apikey from the database with the public key
                $iReturnValue = $this->select(array("p_sColumns" => "*",
                                                    "p_sWhere" => "custom_1 = '$p_sDocument' AND deleted=0 AND client_of= $p_iUserId",
                    ));

                if ($iReturnValue == C_WARNING_SELECTEDOK) {
                    //we get the data of the executed query
                    $someData = $this->get_someData();
                }
                else {
                    return false;
                }
            }
            catch(CException $e) {
                throw $e;
            }

            return $someData;
        }
    
        public function get_someClientsByPhoneOrEmail($p_sClientPhone , $p_sClientEmail , $p_iUserID){
            try {
                $someData = array();
                $iReturnValue = "";

                if(strlen($p_sClientPhone) > 0 && strlen($p_sClientEmail) > 0 ){
                    $iReturnValue = $this->select(array("p_sColumns" => "c.*",
                                                    "p_sTable" => "clients c",
                                                    "p_sWhere" => "( c.email = '$p_sClientEmail' OR c.phone = '$p_sClientPhone' ) AND c.deleted = 0 AND c.client_of = $p_iUserID",
                                                    )
                                             );
                }
                else if(strlen($p_sClientEmail) > 0){
                    $iReturnValue = $this->select(array("p_sColumns" => "c.*",
                                                    "p_sTable" => "clients c",
                                                    "p_sWhere" => "c.email = '$p_sClientEmail' AND c.deleted = 0 AND c.client_of = $p_iUserID",
                                                    )
                                             );
                }
                else if(strlen($p_sClientPhone) > 0){
                    $iReturnValue = $this->select(array("p_sColumns" => "c.*",
                                                    "p_sTable" => "clients c",
                                                    "p_sWhere" => "c.phone = '$p_sClientPhone' AND c.deleted = 0 AND c.client_of = $p_iUserID",
                                                    )
                                             );
                }

                if ($iReturnValue == C_WARNING_SELECTEDOK) {
                    //we get the data of the executed query
                    $someData = $this->get_someData();
                }
                else {
                    return false;
                }
            }
            catch(CException $e) {
                throw $e;
            }

            return $someData;
        }

        public function deleteClientAndUser($p_iClientId , $p_iClientUserId){
            try {
                $iReturnValue = -1;

                $someParameters = array();
                $someParameters["clients"]["deleted"] = 1;

                $sWhere = 'id = '.$p_iClientId;

                $this->startTransaction();

                if($this->update($someParameters,$sWhere,false) == C_WARNING_UPDATEDOK){
                    if(isset ($p_iClientUserId) && $p_iClientUserId != "" ){
                        $someParameters = array();
                        $someParameters["users"]["deleted"] = 1;

                        $sWhere = 'id = '.$p_iClientUserId;

                        if($this->update($someParameters,$sWhere,false) == C_WARNING_UPDATEDOK){
                            $iReturnValue = true;
                        }
                        else{
                            $iReturnValue = false;
                            $this->rollBackTransaction();
                        }
                    }
                    else{
                        $iReturnValue = true;
                    }
                }
                else{
                    $iReturnValue = false;
                    $this->rollBackTransaction();
                }

                $this->endTransaction();

                return $iReturnValue;

            }
            catch(CException $e) {
                throw $e;
            }
        }

        public function getLastClientWithDeletedByUsersId($p_iUsersId){
            try {
                $someClientData = array();

                $iReturnValue = $this->select(array("p_sColumns" => "c.*",
                                                    "p_sTable" => "clients c",
                                                    "p_sWhere" => "c.users_id = '$p_iUsersId' AND c.deleted = 1",
                                                    )
                                             );

                if ($iReturnValue == C_WARNING_SELECTEDOK) {
                    $someData = $this->get_someData();
                    $someData = $someData[count($someData)-1];
                }
            }
            catch(CException $e) {
                throw $e;
            }
        }
    }
?>
