<?php


/**
 * Description of CUser
 * This class manages the access to the table users
 *
 * @author raurope
 */
class CCountrie extends CAppModel
{
    // --- ATTRIBUTES ---
    // --- OPERATIONS ---

    /**
     * Constructor for CUser
     */
    public function CCountrie() {
        try {
            $this->_sTable = 'countries';
        }
        catch(CException $e) {
            throw $e;
        }
    }



    /**
     * This function gets an array of users identified by id
     * @param <type> $p_iIdUser the identifier of the user that we want to retrieve
     * @return <type> returns an array with the user
     */
    public function get_someCountries( $p_iLang ) {
        try {
            $someData = array();
            
            //we get the apikey from the database with the public key
            $iReturnValue = $this->select(array("p_sColumns" => "*",
                "p_sWhere" => "languages_id = $p_iLang",
                "p_sOrder" => "name"
                ));

            if ($iReturnValue == C_WARNING_SELECTEDOK) {
                //we get the data of the executed query
                $someData = $this->get_someData();
            }
            else {
                return false;
            }
        }
        catch(CException $e) {
            throw $e;
        }

        return $someData;
    }

    public function get_internationalCode($p_iCountryId) {
        try {
            $someData = array();

            $iReturnValue = $this->select(array(
                "p_sColumns" => "*",
                "p_sWhere" => "id = $p_iCountryId",
                ));

            if ($iReturnValue == C_WARNING_SELECTEDOK) {
                //we get the data of the executed query
                $someData = $this->get_someData();
            }
            else {
                return false;
            }
        }
        catch(CException $e) {
            throw $e;
        }

        return $someData;
    }
    
     public function get_internationalCodeLang($p_iCountryId, $p_iIdLanguage) {
        try {
            $someData = array();

            $iReturnValue = $this->select(array(
                "p_sColumns" => "*",
                "p_sWhere" => "id = $p_iCountryId and languages_id=$p_iIdLanguage",
                ));

            if ($iReturnValue == C_WARNING_SELECTEDOK) {
                //we get the data of the executed query
                $someData = $this->get_someData();
            }
            else {
                return false;
            }
        }
        catch(CException $e) {
            throw $e;
        }

        return $someData;
    }
}
?>