<?php


class CPayment extends CAppModel {

    public function CPayment() {
        $this->_sTable = "payments";
        
        $this->set_someValidators(
        array(
                "contract" => array(                    
                    "name" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert your name",$this->_sLanguage, true)
                        )
                     ),
                    "surnames" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert your surnames",$this->_sLanguage, true)
                        )
                     ),
                    "street" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert your address",$this->_sLanguage, true)
                        )
                     ),
                    "postalcode" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert the postal code",$this->_sLanguage, true)
                        )
                     ),                   
                    "city" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert a city",$this->_sLanguage, true)
                        )
                     ),
                    "cellphone" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert a cellphone",$this->_sLanguage, true)
                        ),
                        "uniqueCellphone" => array(
                            "message" => __("The cellphone is already registered",$this->_sLanguage, true)
                        )
                     ), 
                    "email" => array(
                        "validEmailRepeat" => array(
                                "message" => __("The email and repeat email must be equals",$this->_sLanguage, true)
                            ),                      
                        C_VALID_NOT_EMPTY => array(
                        "message" => __("You have to insert an email",$this->_sLanguage, true)
                        ),
                        "validEmailString" => array(
                                "message" => __("The email must be valid",$this->_sLanguage, true)
                        ),
                        "uniqueEmail" => array(
                                "message" => __("The email provided already exists",$this->_sLanguage, true)
                        )
                     ),
                 ),
                "trial" => array(
                    "name" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert your name",$this->_sLanguage, true)
                        )
                     ),
                    "country" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to select a country",$this->_sLanguage, true)
                        )
                     ),
                    "cellphone" => array(
                        C_VALID_NOT_EMPTY => array(
                            "message" => __("You have to insert a cellphone",$this->_sLanguage, true)
                        )
                     ),
                    "email" => array(
                        C_VALID_NOT_EMPTY => array(
                        "message" => __("You have to insert an email",$this->_sLanguage, true)
                        ),
                        "validEmailString" => array(
                                "message" => __("The email must be valid",$this->_sLanguage, true)
                        ),
                        "uniqueEmail" => array(
                                "message" => __("The email provided already exists",$this->_sLanguage, true)
                        )
                     ),
                 )
            )
        );
    }
    
    /**
     * This function checks if an email is correct or not.
     * @param type $p_sItem the field to check
     * @param type $p_mValue the content of the field
     * @param type $p_someData the message with the error to be shown
     * @return boolean it returns true if there is an error otherwise will return false.
     */
    public function validEmailString($p_sItem , $p_mValue , $p_someData) {
        try {
            $bReturnValue = true;
            if (trim($p_mValue) != "") {
                if ((substr_count($p_mValue,"@") == 1) && (substr($p_mValue,0,1) != "@") && (substr($p_mValue,strlen($p_mValue)-1,1) != "@")){
                    if (substr_count($p_mValue,".")>= 1){
                        $term_dom = substr(strrchr ($p_mValue, '.'),1);
                        if (strlen($term_dom) >= 1 && (!strstr($term_dom,"@")) ){
                            $bReturnValue = false;
                        }
                    }
                }
            }

            if($bReturnValue == true){
                $this->_someErrors[$p_sItem] = $p_someData["message"];
            }
        }
        catch(CException $e) {
            throw $e;
        }

        return $bReturnValue;
    }
    
   /**
    * This function checks if an email is correct or not.
    * @param type $p_sItem the field to check
    * @param type $p_mValue the content of the field
    * @param type $p_someData the message with the error to be shown
    * @return boolean  if there is an error returns true otherwise will return false.
    */
    public function validEmailRepeat($p_sItem , $p_mValue , $p_someData) {
        try {
            $bReturnValue = true;
            $someParameters = $this->_oController->get_someParameters();
            if (isset($someParameters["data"]["payments"]["reemail"]))
            {
                $sRepeatEmail = $someParameters["data"]["payments"]["reemail"];
                
                //if both are equals
                if (strcmp($sRepeatEmail, $p_mValue) == 0)
                {
                    $bReturnValue = false;
                }
                
            }

            if($bReturnValue == true){
                $this->_someErrors[$p_sItem] = $p_someData["message"];
            }
        }
        catch(CException $e) {
            throw $e;
        }

        return $bReturnValue;
    }
       
   /**
    * This funciton inserts a new order. If the order exists it will do an update.
    * @param type $p_someParameters 
    */
    public function insertPayment($p_someParameters){
        try{
            $p_someParameters["payments"]["date_pay"] = date("Y-m-d");
            if (!isset($p_someParameters["payments"]["state"]))
            {
                $p_someParameters["payments"]["state"] = C_PAYMENT_STATE_BEGIN;
            }
            $p_someParameters["payments"]["deleted"] = 0;
            if (isset($p_someParameters["payments"]["reemail"])) unset($p_someParameters["payments"]["reemail"]);
            
            $oSession = new CAppSession();
            $iIdOrder = $oSession->__get("iIdOrderNube");
            $iIdInserted = -1;
            if ($iIdOrder == false) //if not exists the session variable inserts
            {            
                $iResult = $this->insert($p_someParameters);
                if ($iResult == C_WARNING_INSERTEDOK)
                {                    
                    $iIdInserted = $this->get_iIdLastInserted();
                    $oSession->__set("iIdOrderNube",$iIdInserted);
                }                
            }
            else //else update
            {
                $iIdInserted = $this->updatePayment($p_someParameters);
            }
        }
        catch(CException $e){
            throw $e;
        }
        
        return $iIdInserted;
    }
       
   /**
    * This funcion updates an order.
    * @param type $p_someParameters 
    */
    public function updatePayment($p_someParameters, $p_iIdOrder = null){
        try{            
            $oSession = new CAppSession();
            $iIdOrder = -1;
            if ($p_iIdOrder == null){
                $iIdOrder = $oSession->__get("iIdOrderNube");
            }
            else{
                $iIdOrder = $p_iIdOrder;
            }
            
            $iResult = $this->select(array("p_sColumns" => "*", "p_sWhere" => "id=$iIdOrder"));
            $someData = $this->get_someData();
            $iIdUpdated = -1;
            if (count($someData)>0){            
                $iReturn = $this->update($p_someParameters, "id=$iIdOrder");
             
                if ($iReturn == C_WARNING_UPDATEDOK){
                    $iIdUpdated = $iIdOrder;
                }
                else{
                    $iIdUpdated = -1;
                }
            }
        }
        catch(CException $e){
            throw $e;
        }
        
        return $iIdUpdated;        
    }    
    
    public function logPayment($p_iIdPayment, $p_sText){
        try{
            $iResult = $this->select(array("p_sColumns" => "*", "p_sWhere" => "id=$p_iIdPayment"));
            $someData = $this->get_someData();
            $sText = "";
            if (isset($someData[0]["log"])){
                $sText = $someData[0]["log"];
            }
            
            $someToUpdate = array("log" => $sText." -- next message -- ".$p_sText);
            
            $this->update($someToUpdate, "id=$p_iIdPayment");
        }
        catch(CException $e){
            throw $e;
        }
    }
    
    public function getPaymentById($p_iIdPayment){
        try{
            $iResult = $this->select(array("p_sColumns" => "*", "p_sWhere" => "id=$p_iIdPayment"));
            $someData = $this->get_someData();
            $someResults = array();
            if (count($someData)>0){
                $someResults = $someData;
            }
        }
        catch(CException $e){
            throw $e;
        }
        return $someResults;
    }
    
    public function getPaymentByIdAndAdmin($p_iIdPayment, $p_iIdAdmin){
        try{
            $iResult = $this->select(array("p_sColumns" => "*", 
                "p_sTable" => "payments", 
                "p_sWhere" => "id=$p_iIdPayment AND (users_id IN (SELECT au.users_id FROM admins_users as au WHERE au.admins_id = $p_iIdAdmin))"));
            $someData = $this->get_someData();
            $someResults = array();
            if (count($someData)>0){
                $someResults = $someData;
            }
        }
        catch(CException $e){
            throw $e;
        }
        return $someResults;
    }
    
    

    public function uniqueEmail($p_sItem , $p_mValue , $p_someData){
        try{
            $bReturnValue = false;

            $oSession = new CAppSession();
            $iUserID = $oSession->__get("id");

            if($iUserID > 0){
                $iUserParentId = $this->_oController->_oUser->get_firstParentIdByUserId($iUserID);

                $someUserData = $this->_oController->_oUser->get_someUsersById($iUserParentId);

                if($someUserData[0]["email"] != $p_mValue){
                    $bReturnValue = true;
                }
            }
            else{
                $bReturnValue = $this->_oController->_oUser->checkExistsEmail($p_sItem , $p_mValue , $p_someData);

                if($bReturnValue == true){
                    $this->_someErrors[$p_sItem] = $p_someData["message"];
                }
            }

            return $bReturnValue;
        }
        catch(CException $e){
            throw $e;
        }
    }

    public function uniqueCellphone($p_sItem , $p_mValue , $p_someData){
        try{
            $bReturnValue = false;

            $oSession = new CAppSession();
            $iUserID = $oSession->__get("id");

            if($iUserID > 0){
                $iUserParentId = $this->_oController->_oUser->get_firstParentIdByUserId($iUserID);

                $someUserData = $this->_oController->_oUser->get_someUsersById($iUserParentId);

                if($someUserData[0]["cellphone"] != $p_mValue){
                    $bReturnValue = true;
                }
            }

            return $bReturnValue;
        }
        catch(CException $e){
            throw $e;
        }
    }
    
      
    /**
     * This function creates a real order number. This number could be used to find a concrete order.
     * @param type $p_iIdOrderNumber the id key of the payment to be updated
     * @return type This funciton returns -1 if fails otherwise returns the number of the id for the updated order.
     */
    public function createOrderNumber($p_iIdOrderNumber)
    {
        try
        {
           $iReturn = $this->select(
                        array
                        (
                            "p_sColumns" => "max(nubesis_order_number) as maximus",
                            "p_sTable" => "payments"                            
                        )
           );
           
           $iReturnCreation = -1;
           
           $someData = $this->get_someData();
           if (count($someData) > 0)
           {
               
               $iIdLastOrder = $someData[0]["maximus"];               
               //build the real and final id order
               $iIdLastOrder++;
               $sOrderReference = getPaymentNubesisIdOrder($iIdLastOrder);
               
               //update
               $someParameters["nubesis_order_number"] = $iIdLastOrder;             
               $someParameters["nubesis_order_reference"] = $sOrderReference;             
               $iReturnCreation = $this->updatePayment($someParameters, $p_iIdOrderNumber);
           }
           
            
        }
        catch(CException $e)
        {
            throw $e;
        }
        
        return $iReturnCreation;
    }
    
    
}
?>
