<?php
    /**
     * Short description of class CTimeline
     *
     * @access private
     * @author NUBESIS, <info@nubesis.com>
     */
     class CTimeline extends CAppModel{
        public function CTimeline(){
            $this->_sTable = 'timelines';
        }
        
        public function addTimeline($p_sMessage, $p_sDate, $p_iIdFrom, $p_iIdTo, $p_iAction, $p_iState, $p_iParentId = -1)
        {
            try
            {
                $iReturnValue = -1;
                $someData["text"] = $p_sMessage;
                $someData["date"] = $p_sDate;
                $someData["deleted"] = 0;
                $someData["admins_source_id"] = $p_iIdFrom;
                $someData["admins_target_id"] = $p_iIdTo;
                $someData["action"] = $p_iAction;
                $someData["state"] = $p_iState;
                if ($p_iParentId != -1)
                {
                    $someData["parent_id"] = $p_iParentId;
                }
                
                if ($this->insert($someData) == C_WARNING_INSERTEDOK)
                {
                    $iReturnValue = C_WARNING_INSERTEDOK;
                }
            }
            catch(CException $e)
            {
                throw $e;
            }
            return $iReturnValue;
        }
        
        public function getTimeLineById($p_iIdTimeLine)
        {
            try
            {
                $someData = array();

                //we get the apikey from the database with the public key
                $iReturnValue = $this->select(array("p_sColumns" => "*",
                    "p_sWhere" => "id = $p_iIdTimeLine AND deleted=0",
                    "p_sTable" => "timelines"
                ));

                if ($iReturnValue == C_WARNING_SELECTEDOK) 
                {
                    //we get the data of the executed query
                    $someData = $this->get_someData();
                }
            }
            catch(CException $e)
            {
                throw $e;
            }
            
            return $someData;
        }
        
        
        public function getTextForTimeLine($p_iIdTimeLine, $p_iIdUserFor)
        {
            try 
            {
                
                $sText = "";
                $someTimeLines = $this->getTimeLineById($p_iIdTimeLine);
                                
                if (count($someTimeLines)>0)
                {
                    //this function will get the text to be shown to users
                    if ($someTimeLines[0]["action"] == C_TIMELINE_CREATE_USER)
                    {
                       if ($p_iIdUserFor == $someTimeLines[0]["admins_source_id"])
                       {
                           $sText = __("You sent a request to create a new Client. ",$this->_sLanguage,true);
                       }
                       else
                       {
                           $sText = __("There is a request to create a new Client. ",$this->_sLanguage,true);
                       }
                       
                    }
                    elseif($someTimeLines[0]["action"] == C_TIMELINE_MODIFY_USER)
                    {
                       if ($p_iIdUserFor == $someTimeLines[0]["admins_source_id"])
                       {
                           $sText = __("You sent a request to modify a Client. ",$this->_sLanguage,true);
                       }
                       else
                       {
                           $sText = __("There is a request to modify a Client. ",$this->_sLanguage,true);
                       }
                    }
                    elseif($someTimeLines[0]["action"] == C_TIMELINE_DELETE_USER)
                    {
                       if ($p_iIdUserFor == $someTimeLines[0]["admins_source_id"])
                       {
                           $sText = __("You sent a request to delete a Client. ",$this->_sLanguage,true);
                       }
                       else
                       {
                           $sText = __("There is a request to delete a Client. ",$this->_sLanguage,true);
                       }
                    }
                    elseif($someTimeLines[0]["action"] == C_TIMELINE_ACTIVATE_USER)
                    {
                       if ($p_iIdUserFor == $someTimeLines[0]["admins_source_id"])
                       {
                           $sText = __("You sent a request to activate a Client. ",$this->_sLanguage,true);
                       }
                       else
                       {
                           $sText = __("There is a request to activate a Client. ",$this->_sLanguage,true);
                       }
                    }
                    elseif($someTimeLines[0]["action"] == C_TIMELINE_DEACTIVATE_USER)
                    {
                       if ($p_iIdUserFor == $someTimeLines[0]["admins_source_id"])
                       {
                           $sText = __("You sent a request to deactivate a Client. ",$this->_sLanguage,true);
                       }
                       else
                       {
                           $sText = __("There is a request to deactivate a Client. ",$this->_sLanguage,true);
                       }
                    }
                    elseif($someTimeLines[0]["action"] == C_TIMELINE_SEND_INVOICE)
                    {
                       if ($p_iIdUserFor == $someTimeLines[0]["admins_source_id"])
                       {
                           $sText = __("You sent a request to accept or reject an invoice. ",$this->_sLanguage,true);
                       }
                       else
                       {
                           $sText = __("There is a request to accept or reject an invoice. ",$this->_sLanguage,true);
                       }
                    }                    
                }
            }
            catch(CException $e)
            {
                throw $e;
            }
            
            return $sText;
        }
        
        public function changeState($p_iIdTimeLine, $p_iState)
        {
            try
            {
                $someUpdate = array("state" => $p_iState);
                
                $iResult = $this->update($someUpdate, "id = $p_iIdTimeLine");
                if ($iResult == C_WARNING_UPDATEDOK)
                {
                    return $p_iIdTimeLine;
                }
            }
            catch(CException $e)
            {
                throw $e;
            }
            return -1;
        }
        
        public function getTimelinesBiggerDays($p_iState, $p_iDays, $p_iMaxDay = null)
        {
            try
            {
                $someData = array();
                $sDate = date("Y-m-d H:i:s");
                //we get the apikey from the database with the public key
                
                if ($p_iMaxDay != null)
                {
                    $iReturnValue = $this->select(array("p_sColumns" => "*",
                        "p_sWhere" => "id IN (SELECT id FROM timelines WHERE state = $p_iState 
                        AND ((datediff(created, '$sDate') <= -$p_iDays) AND (datediff(created, '$sDate') > -".$p_iMaxDay.")))",
                        "p_sTable" => "timelines"));
                }
                else
                {
                    $iReturnValue = $this->select(array("p_sColumns" => "*",
                        "p_sWhere" => "id IN (SELECT id FROM timelines WHERE state = $p_iState 
                        AND datediff(created, '$sDate') <= -$p_iDays )",
                        "p_sTable" => "timelines"));
                }

                if ($iReturnValue == C_WARNING_SELECTEDOK) 
                {
                    //we get the data of the executed query
                    $someData = $this->get_someData();
                }
            }
            catch(CException $e)
            {
                throw $e;
            }
            
            return $someData;
        }
     }
?>