<?php

/**
 * This function returns a translated text.
 * @param <string> $p_sTexto text to translate
 * @param <string> $p_bMode 0 or false echo mode. 1 or true return mode.
 * @param <string> $p_sLang language to use
 */
//function __($p_sTexto, $p_sLang = 'en', $p_bMode = false)
//{
//    try{
//        //Check if language file exists
//        $sLanguagePath = '../app/locales/'.$p_sLang.'.php';
//
//        if ( file_exists ( $sLanguagePath ) )
//        {
//            include ($p_sLang.'.php');
//
//            //Check if index value exists
//            if(isset($someDictionary[$p_sTexto]) && isset ($someDictionary))
//            {
//                if ($p_bMode == false)
//                    echo $someDictionary[$p_sTexto];
//                else
//                    return $someDictionary[$p_sTexto];
//            }
//            else
//            {
//                if ($p_bMode == false)
//                    echo $p_sTexto;
//                else
//                    return $p_sTexto;
//            }
//        }
//        else
//        {
//            if ($p_bMode == false)
//                echo $p_sTexto;
//            else
//                return $p_sTexto;
//        }
//    }
//    catch(CException $e) {
//        //redirects to CErrorPage
//        throw $e;
//    }
//}


function __($p_sTexto, $p_sLang = 'en', $p_bMode = false, $p_bStrict = false){
    try{
        global $someDictionary;
        $someLanguageDictionary = array();

        if($p_bStrict){
            $someLanguageDictionary = $someDictionary;
            //Check if language file exists
            $sLanguagePath = '../app/locales/'.$p_sLang.'.php';

            if ( file_exists ( $sLanguagePath ) ){
                include ($p_sLang.'.php');
            }
        }
        
        if(isset($someDictionary[$p_sTexto]) && isset ($someDictionary)){
            if ($p_bMode == false){
                echo $someDictionary[$p_sTexto];
            }
            else{
                $sText = $someDictionary[$p_sTexto];
                if($p_bStrict){
                    $someDictionary = $someLanguageDictionary;
                }
                return $sText;
            }
        }
        else{
            if ($p_bMode == false){
                echo $p_sTexto;
            }
            else{
                if($p_bStrict){
                    $someDictionary = $someLanguageDictionary;
                }
                return $p_sTexto;
            }
        }

        if($p_bStrict){
            $someDictionary = $someLanguageDictionary;
        }
    }
    catch(CException $e) {
        //redirects to CErrorPage
        throw $e;
    }
}

/**
 * This function returns index in dictionary array.
 * @param <string> $p_sTexto text to translate
 * @param <string> $p_sLang language to use
 */
function __search($p_sTexto, $p_sLang = 'en')
{
    try {

        if ($p_sTexto == "") return $p_sTexto; //if text is void it will return void

        //Check if language file exists
        $sLanguagePath = '../app/locales/'.$p_sLang.'.php';

        if ( file_exists ( $sLanguagePath ) )
        {
            include ($p_sLang.'.php');

            //Check if array exists
            if(isset($someDictionary))
            {
                $sKey = array_search($p_sTexto, $someDictionary);
                if($sKey)
                {
                    return array_search($p_sTexto, $someDictionary);
                }
                else
                {
                    return $p_sTexto;
                }
            }
            else
            {
                return $p_sTexto;
            }
        }
        else
        {
            return $p_sTexto;
        }
    }
    catch(CException $e) {
        throw $e;
    }
}

function __isPluginInstalled($p_sRoute) {
    try {
        if (file_exists($p_sRoute)) {
            return true;
        }
    }
    catch(CException $e) {
       throw $e;
    }
    return false;
}

function fieldToId( $p_sField , $p_sBeginning = "" )
{
    $sReturn = $p_sBeginning;
    try {
        $someParts = explode( "_", $p_sField );

        foreach ($someParts as $part)
        {
            $sReturn .= ucfirst($part);
        }
    }
    catch(CException $e) {
       throw $e;
    }
    return $sReturn;
}

function redirect( $p_sUrl = "" , $p_sMessage = "", $p_sType = "", $p_bAbsolute = false )
{
    try
    {
        if( defined ( 'C_ENCRYPT' ) && C_ENCRYPT == 1 )
        {
            $oSession = new CAppSession();
            /*if ($oSession->__get("firsttimevalidation") == false) { //if it's the first time that you login, it will not encrypt url
                 if(!preg_match("/widgets/", $p_sUrl))
                    $p_sUrl = $oSession->encrypt( $p_sUrl );
            } 
            $oSession->delete("firsttimevalidation"); */
        }

        $sUrl = C_ROOT_KEY . $p_sUrl;
        
        if( $p_bAbsolute )
            $sUrl = $p_sUrl;

        if( $p_sMessage != "")
        {
            if ( $p_sType != "")
            {
                $oSession = new CAppSession();
                $oSession->__set("message", $p_sMessage);
                $oSession->__set("messageType", $p_sType);
            }
        }
        
        if (!headers_sent())
        {
            header('Location: '.$sUrl ); exit;
        }
        else
        {
            echo '<script type="text/javascript">';
            echo 'window.location.href="'.$sUrl.'";';
            echo '</script>';
            echo '<noscript>';
            echo '<meta http-equiv="refresh" content="0;url=' . $sUrl . '" />';
            echo '</noscript>'; exit;
        }
    }
    catch(CException $e) {
       throw $e;
    }
}

function redirectError( $p_sUrl = "" , $p_sMessage = "", $p_sSessionId = "")
{
    try
    {
        if( defined ( 'C_ENCRYPT' ) && C_ENCRYPT == 1 )
        {
            $oSession = new CAppSession();
            $p_sUrl = $oSession->encrypt( $p_sUrl );
        }

        if( $p_sMessage != "")
        {
            if ( $p_sSessionId == "")
            {
                $_SESSION['message'] = $p_sMessage;
            }
            else
            {
                $_SESSION[$p_sSessionId] = $p_sMessage;
            }
        }
        if (!headers_sent())
        {
            header('Location: '.C_ROOT_KEY . $p_sUrl ); exit;
        }
        else
        {
            echo '<script type="text/javascript">';
            echo 'window.location.href="'.$p_sUrl.'";';
            echo '</script>';
            echo '<noscript>';
            echo '<meta http-equiv="refresh" content="0;url=' . C_ROOT_KEY . $p_sUrl . '" />';
            echo '</noscript>'; exit;
        }
    }
    catch(CException $e) {
       throw $e;
    }
}
?>