<?php

/**
 * This class allows you manage the sessions of the users that will log in the
 * system.
 *
 * @author Nubesis S.L. http://www.nubesis.com
 */
class CSession {

	private $_sKeyX = "";
	private $_sMd5 = "";
	private $_dTime = "";

	
	/**
         *
         * Constructor for CSession
	 * @param <String> $p_sKey It's the value that will be used to encrypt and decrypt session values.
	 * @param <String> $p_dTime Object It's the duration of the session in minutes.
	 */
	public function CSession($p_sKey=NULL, $p_dTime) {
            if(!is_null($p_sKey)){
                //if a session is not initialized we begin a new one
                if(!isset($_SESSION)){
                        session_start();
                }  

                $sMd5=(md5($p_sKey));
                if($p_dTime==0){
                         $this->_dTime=$this->encrypt(time());
                         $this->_sMd5=$this->encrypt(md5($p_sKey));
                         $this->_sKeyX=$p_sKey;
                         return true;
                //We check if the session is correct. The time must be lower than allowed by the session
                }elseif((md5($p_sKey)==$this->decrypt($this->_sMd5))and((time()-$this->decrypt($this->$dTime))<$p_dTime))
                        {
                                $this->_dTime=$this->encrypt(time());
                                $this->_sMd5=$this->encrypt(md5($p_sKey));
                                $this->_sKeyX=$p_sKey;
                                return true;
                        }else{  
                                self::clean();
                                //Access Denied
                                //print_r('Access Denied');
                                return false;
                        }  
             }
             /*    if(is_null($p_sKey)){
			self::clean();
                        //Access Denied
	 		print_r("Access Denied");
	 		exit();  
	 	  }elseif(!is_null($p_sKey)){
		  	//if a session is not initialized we begin a new one
			if(!isset($_SESSION)){
	 			session_start();
			}  
		
			$sMd5=(md5($p_sKey));
	 		if($p_dTime==0){
				 $this->_dTime=$this->encrypt(time());
			 	 $this->_sMd5=$this->encrypt(md5($p_sKey));
			 	 $this->_sKeyX=$p_sKey;
                        //We check if the session is correct. The time must be lower than allowed by the session
			}elseif((md5($p_sKey)==$this->decrypt($this->_sMd5))and((time()-$this->decrypt($this->$dTime))<$p_dTime)){
			 		$this->_dTime=$this->encrypt(time());
			 		$this->_sMd5=$this->encrypt(md5($p_sKey));
			 		$this->_sKeyX=$p_sKey;
			 	}else{  
					self::clean();
                                        //Access Denied
					print_r('Access Denied');
					exit;  
			  	}  
			}else{  
				self::clean();
                                //Access Denied
				print_r('Access denied');
				exit;  
	 	   }  */
	}
	
	
	 /**
          * This function allows assign a value to a session var.
	  * @param $sVariable Object para introducir un valor a una sesion
	  * @param $sValor Object valor que queremos poner
	  */
	 public function __set($p_sNameVar,$p_sValueVar)
	 {
                if(!isset($_SESSION[md5($p_sNameVar.$this->_sKeyX)]))
			$this->register(md5($p_sNameVar.$this->_sKeyX));
	 	$_SESSION[md5($p_sNameVar.$this->_sKeyX)]=$this->encrypt($p_sValueVar);
	 }  
	 
	 public function __setArray($p_sNameVar, $p_sValueVar) {
	 	$_SESSION[$p_sNameVar] = $p_sValueVar;
	 }
	
	 /**
	  * This function returns the value of a variable stored in a session.
	  * @return returns the value of a variable stored in session. If the variable doesn't exists the function will return false.
	  * @param <string> $sVariable The variable name that we want get.
	  */
	public function __get($p_sNameVar)
	{
                if(isset($_SESSION[md5($p_sNameVar.$this->_sKeyX)]))
		{
			return $this->decrypt($_SESSION[md5($p_sNameVar.$this->_sKeyX)]);

                }
		else
                {
			return false;
                }
	}  
	
	public function __getArray($p_sNameVar) {
                if (isset($_SESSION[$p_sNameVar])) {
			return $_SESSION[$p_sNameVar];
		}
		else {
			return array();
		}
		
	}
	
	
	/**
	 * This function stores a variable in the session
	 * @return 
	 * @param <String> $sVariable Name of the var that we want to store in the session
	 */
	private function register($p_sNameVar)
	{
                if(isset($_SESSION[md5($p_sNameVar.$this->_sKeyX)]))
                        $_SESSION[md5($p_sNameVar.$this->_sKeyX)] = "";
                    //session_register(md5($p_sNameVar.$this->_sKeyX));
	}  
	
	/**
	 * This function deletes a variable passed by parameter
	 * @param <String> $p_sNamevar The name of the var to delete
	 */ 
	public function delete($p_sNameVar)
	{  
		$_SESSION[md5($p_sNameVar.$this->_sKeyX)]='';
                unset($_SESSION[md5($p_sNameVar.$this->_sKeyX)]);
		//session_unregister(md5($p_sNameVar.$this->_sKeyX));
	}  
	
	
	/**
	 * Destroys absolutely the session
	 */
	public function clean()
	{  
            session_destroy();            
	}
	  
	/**
	 * This function show us the number of users that are connected to
         * the system with a session.
	 * @return <Integer> Number of users online through sessions mode
	 */
	public function usersOnline() {
		$iCount=0;  
		$sHandle=opendir(session_save_path());  
		if($sHandle==false) return-1;  
		while (($file = readdir($sHandle))!=false)  
		if (ereg("^sess",$file))  
		if(time()-fileatime(session_save_path().'/'.$file)<120) // 120 secs = 2 minutes session  
			$iCount++;  
		
		closedir($sHandle);  
		return $iCount;  
	}  
  
	/**
	 * Function to propietary encrypt of the sessions
         * @return <String> data encrypted
	 * @param $t Object
	 */
	private function ed($t)  
	{  
		$r = md5($this->k);  
		$c=0;  
		$v = "";  
		for ($i=0;$i<strlen($t);$i++) {  
			if ($c==strlen($r)) $c=0;  
			$v.= substr($t,$i,1) ^ substr($r,$c,1);  
			$c++;  
		}  
		return $v;  
	}  
   
   	/**
	 * Function to encrypt data values for session
	 * @return 
	 * @param $t Object
	 */
	public function encrypt($t)
	{  
		if(!is_array($t)){  
			$t=urlencode($t);  
			srand((double)microtime()*1000000);  
			$r = md5(rand(0,32000));  
			$c=0;  
			$v = "";  
			
			for ($i=0;$i<strlen($t);$i++){  
				if ($c==strlen($r)) $c=0;  
					$v.= substr($r,$c,1) .(substr($t,$i,1) ^ substr($r,$c,1));  
					$c++;  
			}  
			
			//$v = base64_encode($this->ed($v));
                        $v = $this->base64url_encode($this->ed($v));
			//$v = str_replace('+','AbCdE',$v);
			$v = str_replace('+','ZyXwV',$v);  
			return $v;  
		}else{  
			foreach($t as $x=>$y)  
				$s[$x] = $this->encrypt($y);
				return $s;  
		}  
	}  
  
  	/**
	 * Function to decrypt data values for session
	 * @return 
	 * @param $t Object
	 */
	public function decrypt($t)
	{  
             if(!is_array($t)){
                 //$t = str_replace('AbCdE','+',$t);
                 $t = str_replace('ZyXwV','+',$t);

                 $sValue = $this->base64url_decode($t);
                 $t = $this->ed($sValue);
                 //$t = $this->ed(base64_decode($t));
                 $v = "";
                 for ($i=0;$i<strlen($t);$i++){
                 $md5 = substr($t,$i,1);
                 $i++;
                 $v.= (substr($t,$i,1) ^ $md5);
                 }
                 return urldecode($v);
                 }else{
                 foreach($t as $x=>$y)
                 $s[$x] = $this->decrypt($y);
                 return $s;
             }
	 }
	 
	 /**
	 * This function encrypts the session of the user

	 * @param <string> $t string that we want to encrypt
	 * @param <string> $id identifier that we want encrypt
         * @return <string> String with encrypted result
	 */
	public function encrypt_id($t, $id)
	{  
		if(!is_array($t)){  
			$t=urlencode($t);  
			srand((double)microtime()*1000000);  
			//$r = md5(rand(0,32000))
			$r = md5($id);  
			$c=0;  
			$v = "";  
			
			for ($i=0;$i<strlen($t);$i++){  
				if ($c==strlen($r)) $c=0;  
					$v.= substr($r,$c,1) .(substr($t,$i,1) ^ substr($r,$c,1));  
					$c++;  
			}  
			
			$v = base64_encode($this->ed($v));  
			//$v = str_replace('+','AbCdE',$v);
			$v = str_replace('+','ZyXwV',$v);  
			return $v;  
		}else{  
			foreach($t as $x=>$y)  
				$s[$x] = $this->encrypt($y);
				return $s;  
		}  
	}  
    
	public function base64url_encode($data) {
          return rtrim(strtr(base64_encode($data), '+/', '-_'), '=');
        }

        public function base64url_decode($data) {
            return base64_decode(str_pad(strtr($data, '-_', '+/'), strlen($data) % 4, '=', STR_PAD_RIGHT));
        }
	 
	 /**
	  * This function gets the IP number of the stablished session.
	  * @return <String> string with the ip direction
	  */
	 function getIP(){  
		if(getenv("HTTP_CLIENT_IP")&&strcasecmp(getenv("HTTP_CLIENT_IP"),"0.0.0.0")){  
			$ip=getenv("HTTP_CLIENT_IP");  
		}elseif(getenv("HTTP_X_FORWARDED_FOR")&&strcasecmp(getenv("HTTP_X_FORWARDED_FOR"),"0.0.0.0")){  
                    $ip=getenv("HTTP_X_FORWARDED_FOR");
                            }elseif(getenv("REMOTE_ADDR")&&strcasecmp(getenv("REMOTE_ADDR"), "0.0.0.0")){
                    $ip=getenv("REMOTE_ADDR");
                            } elseif(isset($_SERVER['REMOTE_ADDR'])&&$_SERVER['REMOTE_ADDR']&&strcasecmp($_SERVER['REMOTE_ADDR'],"0.0.0.0")){
                    $ip=$_SERVER['REMOTE_ADDR'];
                            }else{
                    error('Autorizaci n no v lida. Acceso denegado');
                    exit;
  		}  
  		return $ip;
	}  
	
	
	
}


?>