<?php
/**
 * This is the core configuration that is required by the URL dispatcher and
 * core library.
 * @author Nubesis http://www.nubesis.com
 * @copyright Nubesis S.L.
 */


/*
 * These two constants have the similar values. The difference is that, the second
 * constant hasn't a slash in the first char, but the first
 * has a slash. C_ROOT_KEY have the value where is installed the application, under the WEB SERVER publication directory .
 *
 * For example:
 * C_KEY_MAIN -> directory/
 * C_ROOT_KEY -> /directory/
 *
 * Allways in the public application directory of your WEB SERVER.
 *
 * You mustn't change these values, the installation directory of the application is calculated, not hardcoded.
 */

//define('C_KEY_MAIN', substr(str_replace('public/index.php', '', $_SERVER['PHP_SELF']), 1));
//define('C_ROOT_KEY', str_replace('public/index.php', '', $_SERVER['PHP_SELF']));
define('C_KEY_MAIN', substr(C_ROOT_KEY, 1));


/**
 * This constant has the absolute realpath of the application directory. For example if we have
 * publicated the application in /var/www/myapp/, this constant will have the value /var/www/myapp.
 * It will be used in the core for some actions, for example set_include_path.
 */
define('C_ROOT', realpath(dirname(__FILE__) . '/../'));
/**
 * The Path for CORE directory.
 */
define('C_CORE', C_ROOT . '/core/');

/**
 * Folder for core application controllers.
 * This directory is initialized in the include path.
 */
define('C_BKT_CONTROLLERS', C_CORE . 'controllers/');

/**
 * Folder for core application models.
 * This directory is initialized in the include path.
 */
define('C_BKT_MODELS', C_CORE . 'models/');

/**
 * Folder for core application helpers.
 * This directory is initialized in the include path.
 */
define('C_BKT_HELPERS', C_CORE . 'helpers/');

/**
 * 404 error page.
 */
define ('C_FILE_NOT_FOUND', C_ROOT . '/app/views/errors/404.php');

/**
 * The file begining char for PHP classes.
 */
define('C_CLASS_FILE', 'C');

/**
 * The file begining char for PHP Controller classes.
 */
define('C_CONTROLLER_CLASS', 'Controller');

/**
 * The Path for APP directory.
 */
define('C_APP', C_ROOT . '/app/');

/**
 * Folder for application controllers.
 * This directory is initialized in the include path.
 */
define('C_CONTROLLERS', C_APP . 'controllers/');

/**
 * The Components controllers path.
 */
define('C_COMPONENTS', C_CONTROLLERS . 'components/');

/**
 * Folder for classes that are not models.
 * This directory is initialized in the include path.
 */
define('C_LIBS', C_APP . 'libs/');
define('C_BASES', C_APP . 'bases/');
define('C_APP_CONFIG',C_APP. 'config/');

/**
 * Folder for models of the application.
 * This directory is initialized in the include path.
 */
define('C_MODELS', C_APP.  'models/');

/**
 * Folder for models of the application.
 * This directory is initialized in the include path.
 */
define('C_PLUGINS', C_APP.  'plugins/');

/**
 * The default template path. An application can override this or ignore this
 * constant as it only should be seen as a recommendation. This directory will
 * be placed on the include path.
 */
define('C_VIEWS', C_APP . 'views/');

/**
 * The Elements views path.
 */
define('C_ELEMENTS', C_VIEWS . 'elements/');

/**
 * The Helpers views path.
 */
define('C_HELPERS', C_VIEWS . 'helpers/');

/**
 * The Frontend Views path.
 */
define('C_FRONTEND', 'frontend/');

/**
 * The Frontend Views path.
 */
define('C_ERRORS', 'errors/');

/**
 * The Frontend Views path.
 */
define('C_PAGES', 'pages/');

/**
 * The Api path
 */
define('C_API',C_APP.'api/');

/**
 * The Backend Views path.
 */
define('C_BACKEND', 'backend/');

/**
 * The Frontend Layouts path.
 */
define('C_LAYOUTS', 'layouts/');

/**
 * The default template path. An application can override this or ignore this
 * constant as it only should be seen as a recommendation. This directory will
 * be placed on the include path.
 */
define('C_DEFINES', C_APP . 'defines/');

/**
 * The default template path. An application can override this or ignore this
 * constant as it only should be seen as a recommendation. This directory will
 * be placed on the include path.
 */
define('C_ROUTES', C_APP . 'routes/');

/**
 * The default template path. An application can override this or ignore this
 * constant as it only should be seen as a recommendation. This directory will
 * be placed on the include path.
 */
define('C_LOCALES',C_APP. 'locales/');

/**
 * This is the path for special classes
 */

define ('C_CORECLASSES',C_CORE. 'classes/');



/**
 * Constant denoting the error reporting level.
 * 0. Show errors only.
 * 1. Show warnings and errors.
 * 2. Show notices, warnings and errors.
 */
if(!defined("C_DEBUG") )
{
    define('C_DEBUG', 1);
}
/**
 * Constant denoting the GMT server
 */
if(!defined("C_SERVER_GMT") )
{
    define('C_SERVER_GMT', "+0:00");
}

/**
 * The DS is de DIRECTORY_SEPARATOR.
 * It could be change id your SO or your browser need it.
 */
define('C_DS', '/');

//
define("C_TYPE_ERROREXCEPTION",1);

//Error Definitions
define("C_ERROR_ALLOK",0);
define("C_ERROR_GENERAL", -1);
define("C_ERROR_NOCONNECTION",-3);
define("C_ERROR_EXECSQL",-120);
define("C_ERROR_EXCEPTION",-121);
define("C_ERROR_INSERTLOG",-122);
define("C_ERROR_CONNECTSQL",-123);
define("C_ERROR_APINOTCONNECTED",-124);
define("C_ERROR_CONTROLLERNOTDEFINED",-125);
define("C_ERROR_REQUESTMETHOD",-126);
define("C_ERROR_VALIDATORS",-127);
define("C_ERROR_404ERROR",-404);

//Warning Definitions. It will be defined from -10000
define("C_WARNING_INSERTEDOK", -10008);
define("C_WARNING_SELECTEDOK", -10009);
define("C_WARNING_UPDATEDOK",-10010);
define("C_WARNING_DELETEOK",-10011);
define("C_WARNING_DESCRIBEOK",-10012);

define("C_TITLE_PAGE",'.:: BOOKITIT ::.');
define("C_METAKEYWORDS",'BOOKITIT');
define("C_METADESCRIPTION",'BOOKITIT');

define("C_VALID_NOT_EMPTY","valid_not_empty");
define("C_VALID_NOT_EQUAL","valid_not_equal");
define("C_VALID_DOUBLE","valid_double");
define("C_VALID_MAX","valid_max");
define("C_VALID_MIN","valid_min");
define("C_VALID_STRING","valid_string");
define("C_VALID_NUMBER","valid_number");

define("C_ERROR_VIEW","error");
define("C_ERROR_SESSION","errorTrace");
?>
