<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of CBuilder
 *
 * @author raurope
 */
class CBuilder {
    //put your code here
    protected $_sFolder = "";

    public function CBuilder() {
        
    }

    /**
     * This function get folder controller files
     * @param <string> $p_sPath path of core controllers
     * @param <string> $p_sRoot path of folder installation (usually '/')
     * @return <array> hash table with core controllers
     */
    protected function getFilesControllers($p_sPath)
    {
        $oDir = opendir($p_sPath);

        $someControllers = array();

        while ($sElement = readdir($oDir))
        {
            $someElements = explode(".",$sElement) ;
            $sName = $someElements[0] ;

            $sExtension = "";
            if(isset ($someElements[1]))
            {
                $sExtension  = $someElements[1] ;
            }

            $someTypes= array ("php");

            if(in_array($sExtension, $someTypes)){
                $sClassName = substr(str_replace('Controller', '', $sName), 1);

                $sUrl = strtolower($sClassName);

                $someControllers[$sUrl] = array("controller" =>$sClassName);
            }
        }

        closedir($oDir);

        return $someControllers;
    }



    /**
     * This function get folder controller files
     * @param <string> $p_sPath path of core controllers
     * @param <string> $p_sRoot path of folder installation (usually '/')
     * @return <array> hash table with core controllers
     */
    protected function getFilesPluginsControllers($p_sPath)
    {
        $oDir = opendir($p_sPath);

        $someControllers = array();

        while ($sElement = readdir($oDir))
        {
            if(!preg_match('/\./',$sElement))
            {
                if(file_exists($p_sPath . $sElement.'/controllers/'))
                {
                    $oPluginDir = opendir($p_sPath . $sElement . '/controllers/');

                    while($sPluginController = readdir($oPluginDir))
                    {
                        $somePluginControllers = explode(".",$sPluginController) ;

                        $sName = $somePluginControllers[0] ;

                        $sExtension = "";

                        if(isset ($somePluginControllers[1]))
                        {
                            $sExtension  = $somePluginControllers[1] ;
                        }

                        $someTypes= array ("php");

                        if(in_array($sExtension, $someTypes)){

                            $sClassName = substr(str_replace('Controller', '', $sName), 1);

                            $sUrl = strtolower($sClassName);

                            $someControllers[$sUrl] = array("controller" =>$sClassName);

                        }
                    }

                    closedir($oPluginDir);

                }
            }
        }

        closedir($oDir);

        return $someControllers;
    }


    /**
     * This function create a file
     * @param <string> $p_sFileRoute Route where the file will be created
     * @param <string> $p_sResult Content to write in the file will be created
     * @return <string> Message with the result of createFile
     */
    protected function createFile($p_sFileRoute, $p_sResult)
    {
        $return = '';
        if (is_file($p_sFileRoute))
        {
            //delete existent file
            unlink($p_sFileRoute);
        }

        if (($p_sResult != "") && ($p_sResult != null))
        {
            //Open and write file
            $oHandle = fopen($p_sFileRoute,"w+");

            if (fwrite($oHandle, $p_sResult) === FALSE)
            {
                $return = "Can't create ".$p_sFileRoute." file.\n";
            }
            else
            {
                $return = "File ".$p_sFileRoute." Created.\n";
            }

            //Close file
            fclose($oHandle);
        }

        return $return;
    }


    protected function renderAddArray($p_sLanguage, $p_someControllers, $p_sRoot, $p_bFileExist = true, $p_isPlugin = false )
    {
        $sResult = '';

        if($p_bFileExist)
        {
            include ($p_sLanguage.'.php');

            foreach ($p_someControllers as $index => $controller)
            {
                $sPath = $index;

                if(isset($someDictionary[$index]))
                {
                    $sPath = $someDictionary[$index];
                }

                $sResult .= '$this->_someInitValues["'.$p_sLanguage.'"]["'.$p_sRoot.$sPath."/*".'"] = array("controller" => "'.$controller['controller'].'");
                    ';
            }

            $sIndexControler = 'Mainpage';

            if(defined('C_INDEX_CONTROLLER'))
            {
                $sIndexControler = C_INDEX_CONTROLLER;
            }

            if(!$p_isPlugin)
            {
                $sResult .= '$this->_someInitValues["'.$p_sLanguage.'"][C_KEY_MAIN."*"] = array("controller" => "'.$sIndexControler.'");
                        $sOthers = substr(C_KEY_MAIN, 0, -1)."*";
                        $this->_someInitValues["'.$p_sLanguage.'"][$sOthers] = array("controller" => "'.$sIndexControler.'"); ';
            }
        }
        else
        {
            $sResult .= '"'.$p_sLanguage.'" => array (
                ';

            foreach ($p_someControllers as $index => $controller)
            {
                $sPath = $index;

                $sResult .= '$this->_someInitValues["'.$p_sLanguage.'"]["'.$p_sRoot.$sPath."/*".'"] = array("controller" => "'.$controller['controller'].'");
                    ';
            }

            $sIndexControler = 'Mainpage';

            if(defined('C_INDEX_CONTROLLER'))
            {
                $sIndexControler = C_INDEX_CONTROLLER;
            }

            if(!$p_isPlugin)
            {
                $sResult .= '$this->_someInitValues["'.$p_sLanguage.'"][C_KEY_MAIN] = array("controller" => "'.$sIndexControler.'");
                        $sOthers = substr(C_KEY_MAIN, 0, -1)."*";
                        $this->_someInitValues["'.$p_sLanguage.'"][$sOthers] = array("controller" => "'.$sIndexControler.'"); ';
            }
        }

        return $sResult;
    }

    protected function renderArray($p_sLanguage, $p_someControllers, $p_sRoot, $p_bFileExist = true)
    {
        $sResult = '';

        if($p_bFileExist)
        {
            include ($p_sLanguage.'.php');

            $sResult .= '"'.$p_sLanguage.'" => array (
                ';

            foreach ($p_someControllers as $index => $controller)
            {
                $sPath = $index;

                if(isset($someDictionary[$index]))
                {
                    $sPath = $someDictionary[$index];
                }

                $sResult .= '"'.$p_sRoot.$sPath."/*".'" => array (
                    "controller" => "'.$controller['controller'].'"
                )
            ,';
            }

            $sResult = substr($sResult, 0, -1);

            $sResult .= ')
            ,';
        }
        else
        {
            $sResult .= '"'.$p_sLanguage.'" => array (
                ';

            foreach ($p_someControllers as $index => $controller)
            {
                $sPath = $index;

                $sResult .= '"'.$p_sRoot.$sPath."/*".'" => array (
                    "controller" => "'.$controller['controller'].'"
                )
            ,';
            }

            $sResult = substr($sResult, 0, -1);

            $sResult .= ')
            ,';
        }

        return $sResult;
    }

    /**
     * This function create adds to hash table cora controllers with app controllers prepare for insert in file
     * @param <type> $p_someControllers $p_someControllers hash table with app controllers
     * @return <type> string with hash table with app controllers for append in file will be created
     */
    protected function createAddsHashTable($p_someControllers, $p_sRoot, $p_isPlugin = false)
    {
        $sResult = '';

        if(defined('C_LANGUAGES'))
        {

            $someLanguages = explode(',',C_LANGUAGES);

            foreach ($someLanguages as $sLanguage)
            {
                $sLanguagePath = str_ireplace('core'.DIRECTORY_SEPARATOR.'console',
                                              '',
                                              getcwd()).'app'.DIRECTORY_SEPARATOR.'locales'.DIRECTORY_SEPARATOR.$sLanguage.'.php';

                if(file_exists($sLanguagePath))
                {
                    $sResult .= $this->renderAddArray($sLanguage, $p_someControllers, $p_sRoot, true, $p_isPlugin);
                }
                else
                {
                    $sResult .= $this->renderAddArray($sLanguage, $p_someControllers, $p_sRoot, false, $p_isPlugin);
                }
            }

            $sResult = substr($sResult, 0, -1);
        }
        else
        {
            if(defined('C_LANGUAGE_DEFAULT'))
            {
                $sLanguagePath = str_ireplace('core'.DIRECTORY_SEPARATOR.'console',
                                              '',
                        getcwd()).'app'.DIRECTORY_SEPARATOR.'locales'.DIRECTORY_SEPARATOR.C_LANGUAGE_DEFAULT.'.php';

                if(file_exists($sLanguagePath))
                {
                    $sResult = $this->renderAddArray(C_LANGUAGE_DEFAULT, $p_someControllers, $p_sRoot, true , $p_isPlugin);
                }
                else
                {
                    $sResult = $this->renderAddArray(C_LANGUAGE_DEFAULT, $p_someControllers, $p_sRoot, false , $p_isPlugin);
                }

                $sResult = substr($sResult, 0, -1);
            }
            else
            {
                $sLanguagePath = str_ireplace('core'.DIRECTORY_SEPARATOR.'console',
                        '',
                        getcwd()).'app'.DIRECTORY_SEPARATOR.'locales'.DIRECTORY_SEPARATOR.'en.php';

                if(file_exists($sLanguagePath))
                {
                    $sResult = $this->renderAddArray('en', $p_someControllers, $p_sRoot, true , $p_isPlugin);
                }
                else
                {
                    $sResult = $this->renderAddArray('en', $p_someControllers, $p_sRoot, false , $p_isPlugin);
                }

                $sResult = substr($sResult, 0, -1);

            }
        }

        return $sResult;

    }

    /**
     * This function creates a hash table with the core controllers that must be inserted inside the file
     * @param <hash table> $p_someControllers hash table with core controllers
     * @return <string> string with hash table with core controllers for append in file will be created
     */
    function createHashTable($p_someControllers, $p_sRoot)
    {
        $sResult = '';

        if(defined('C_LANGUAGES'))
        {
            $someLanguages = explode(',',C_LANGUAGES);

            foreach ($someLanguages as $sLanguage)
            {
                $sLanguagePath = str_replace('core/console', '', getcwd()).'app/locales/'.$sLanguage.'.php';

                if(file_exists($sLanguagePath))
                {
                    $sResult .= $this->renderArray($sLanguage, $p_someControllers, $p_sRoot);
                }
                else
                {
                    $sResult .= $this->renderArray($sLanguage, $p_someControllers, $p_sRoot, false);
                }
            }

            $sResult = substr($sResult, 0, -1);
        }
        else
        {
            if(defined('C_LANGUAGE_DEFAULT'))
            {
                $sLanguagePath = str_replace('core/console', '', getcwd()).'app/locales/'.C_LANGUAGE_DEFAULT.'.php';

                if(file_exists($sLanguagePath))
                {
                    $sResult = $this->renderArray(C_LANGUAGE_DEFAULT, $p_someControllers, $p_sRoot);
                }
                else
                {
                    $sResult = $this->renderArray(C_LANGUAGE_DEFAULT, $p_someControllers, $p_sRoot, false);
                }

                $sResult = substr($sResult, 0, -1);
            }
            else
            {
                $sLanguagePath = str_replace('core/console', '', getcwd()).'app/locales/en.php';

                if(file_exists($sLanguagePath))
                {
                    $sResult = $this->renderArray('en', $p_someControllers, $p_sRoot);
                }
                else
                {
                    $sResult = $this->renderArray('en', $p_someControllers, $p_sRoot, false);
                }

                $sResult = substr($sResult, 0, -1);

            }
        }

        return $sResult;
    }

    public function get_sFolder() {
        return $this->_sFolder;
    }

    public function set_sFolder($p_sFolder) {
        $this->_sFolder = $p_sFolder;
    }


}
?>
