<?php


require_once("CBuilder.php");
require_once("CBaseIniBuilder.php");
require_once("CAppIniBuilder.php");
require_once("CHtaccessBuilder.php");
require_once("CBehavioursBuilder.php");
require_once("CScaffoldBuilder.php");

/**
 * This file will replace the previous file "script.php". It will have
 * the most general function to be used by the other classes of the compiler.
 *
 * @author raurope
 */
class CNuvolBuilder {
    //put your code here


    public function CNuvolBuilder($p_oConsoleDispatcher) {

        //we check the options selected by users
        if ($p_oConsoleDispatcher->get_sScaffoldFront()!="")
            $someTablesToScaffold = explode(",",$p_oConsoleDispatcher->get_sScaffoldFront());
        else
            $someTablesToScaffold = array();

        if ($p_oConsoleDispatcher->get_sScaffoldBack() != "")
            $someTablesToScaffoldBack = explode(",",$p_oConsoleDispatcher->get_sScaffoldBack());
        else
            $someTablesToScaffoldBack = array();

        if ($p_oConsoleDispatcher->get_sScaffoldPlugin() != "")
            $someTablesToScaffoldPlugin = explode(",",$p_oConsoleDispatcher->get_sScaffoldPlugin());
        else
            $someTablesToScaffoldPlugin = array();

        
        $sFolder = C_ROOT_KEY;

        //First, scaffold
        $oScaffolding = new CScaffoldBuilder();
        echo $oScaffolding->createScaffolding($someTablesToScaffold,"frontend");
        echo $oScaffolding->createScaffolding($someTablesToScaffoldBack,"backend");
        echo $oScaffolding->createScaffolding($someTablesToScaffoldPlugin,"plugins");

        //second BaseIni
        $oBaseIniBuilder = new CBaseIniBuilder($sFolder);
        echo $oBaseIniBuilder->createCBaseIni();

        //third AppIni
        $oBaseAppIni = new CAppIniBuilder($sFolder);
        echo $oBaseAppIni->createCAppIni();

        //fourth, Htaccess
        $oBaseHtaccess = new CHtaccessBuilder($sFolder);
        echo $oBaseHtaccess->crateHtaccess();

        //fifth, Behaviours
        $oBaseBehaviours = new CBehavioursBuilder($sFolder);
        echo $oBaseBehaviours->crateBehaviours();

    }
}
?>
