<?php


/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of CBaseapiController this controller allow users access to the database remotely.
 * We have used a Basic authentication for api users validation. After study Basic and Digest
 * validation we decided to use Basic because the data values must be passed encrypted, and the data
 *
 * @author raurope
 */
class CBaseapiController extends CAppController {

    protected $_sDefaultMethod = 'valid';

    public function CBaseapiController() {
        try {
            $this->CAppController();
            $this->setType(C_API);
        }
        catch(CException $e) {
            throw $e;
        }
    }

    public function valid() {
        try {
            $bReturnValue = false;
            $this->setSomeParameters($_GET,"get");
            $sRealm = 'Restricted area';
            $sResult = "";
            //before to process the request we have to test the authentication
            // figure out if we need to challenge the user
            if(empty($_SERVER['PHP_AUTH_USER']))
            {
                header('HTTP/1.1 401 Unauthorized');
                header('WWW-Authenticate: Basic realm="'.$sRealm.'"');
                // show the error if they hit cancel
                die('This api connection site needs a true authentication. You can not pass.');
                //we must log this action
                return $bReturnValue;
            }

            
            //we authenticate user and password with md5. Other option is pass the id company with md5 like an api key
            if (($this->authenticateAPI($_SERVER['PHP_AUTH_USER'],$_SERVER['PHP_AUTH_PW'])) == false)
            {
                 die('Your api number or authentication login and password are incorrects.');
                 return $bReturnValue;
                //we must log this action
            }

            //your api key is correct and validated
            $bReturnValue = true;


        }
        catch(CException $e) {
            throw $e;
        }

        return $bReturnValue;
    }

    public function doPost() {
          try {
              return $this->doGet();
              /*  $this->setSomeParameters($_POST);
            //before to process the request we have to test the authentication
            if ((isset($this->_someParameters['user']) && isset($this->_someParameters['password']))) {
                //we have to access to the database to authenticate the user
                $bValue = $this->authenticateAPI($this->_someParameters['user'], $this->_someParameters['password']);
                if ($bValue == true) {
                     $oRestObject = CRestUtils::processRequest("get",$this->_someParameters);
                     $oData = $oRestObject->getData();
                     $sXml = CRestUtils::WriteToXML($oData);
                }
                else {

                }

            }
            $data = CRestUtils::processRequest("post",$this->_someParameters);
        if (isset($this->_someParameters["number"])) {
                $sErrorText = CErrorMessages::getMessage($this->_someParameters["number"]);
                $this->_oView->add("errorMessage",$sErrorText);
                $this->display($this->_oView);
            }
            else {
                return C_ERROR_404ERROR;
            } */
        }
        catch(CException $e) {
            throw $e;
        }
    }
    
    public function doDelete() {
          try {
            return $this->doGet();
       /*     $this->setSomeParameters($_GET);
            $data = CRestUtils::processRequest("delete",$this->_someParameters);
           if (isset($this->_someParameters["number"])) {
                $sErrorText = CErrorMessages::getMessage($this->_someParameters["number"]);
                $this->_oView->add("errorMessage",$sErrorText);
                $this->display($this->_oView);
            }
            else {
                return C_ERROR_404ERROR;
            } */
        }
        catch(CException $e) {
            throw $e;
        }
    }

    public function doPut() {
         try {
            return $this->doGet();
            // basically, we read a string from PHP's special input location,
				// and then parse it out into an array via parse_str... per the PHP docs:
				// Parses str  as if it were the query string passed via a URL and sets
				// variables in the current scope.
		 /*		parse_str(file_get_contents('php://input'), $put_vars);
				$data = $put_vars;

            $this->setSomeParameters($_GET);
            $data = CRestUtils::processRequest("put",$this->_someParameters); */
          
        }
        catch(CException $e) {
            throw $e;
        }
    }


    /**
     ** This function validates an apikey and return true or false if the api is correct or not for the given data values.
     * @param <type> $p_sApiKeyPub public api key that we give to all users
     * @param <type> $p_sApiKeyHash hashed values that we want to pass. These values are hashed with the private key.
     * @return <type> true if the api is correct or false if the api is incorrect
     */
    public function authenticateAPI($p_sApiKeyPub, $p_sApiKeyHash) {
        try {
            $someParameters = $this->get_someParameters();
            //we have to order them in a correct order
            $sToHash = "";
            $sToHash=implode("/",$someParameters);
            
            $sHeader=$_SERVER['HTTP_HOST'];            
   
            if (C_API_MULTIAPI == true)
            {
                        
                //we get the apikey from the database with the public key
                $oApiKey = new CApiKey();
                $oApiKey->select(array("p_sColumns" => "*","p_sTable" => "apikeys", "p_sWhere" => "apikeypub = '".$p_sApiKeyPub."'"));

                //we get the data of the executed query
                $someData = $oApiKey->get_someData();
 

                //Now we have to check if the retrieved api keys are correct with passed values. We have
                //to hash the passed parameters from the client. If this hash is equal to the apiKeyHash calculated in the client
                //it want means that the communication is correct.
                if (count($someData) >= 1) {
                    //we get the returned values of the query
                    $oApiKeyAux = $someData[0];
                    //we take the column apikeypriv
                    $sApiKeyPriv = $oApiKeyAux['apikeypriv'];
                    //and finally we build the hash with the information to compare with the hash sent by the client
                    $sHashDataKey = hash_hmac("md5", $sToHash, $sApiKeyPriv);
                    if (strcmp($p_sApiKeyHash, $sHashDataKey) == 0) {                        
                        return true;
                    }
                    else { //we log it in the database
                        $oLogController = new CLogController();
                        $bInserted = $oLogController->insertLog("Key Hash client: ".$p_sApiKeyHash. " Key Hash server calculated: ".$sHashDataKey.
                                " url server: ".$sHeader
                                ,"CBaseapiController::authenticateAPI()", array());
                    }

                }
                else
                {
                    $oLogController = new CLogController();
                    $bInserted = $oLogController->insertLog("Public Key Problem. Public Key not found in database. Public key: ".$p_sApiKeyPub.
                            " url server: ".$sHeader,"CBaseapiController::authenticateAPI()", array());
                }
            }
            else //if api isn't in multiapi mode, you only have one key number
            {
                if (C_API_PUBLIC_KEY == $p_sApiKeyPub) {
                    $sHashDataKey = hash_hmac("md5", $sToHash, C_API_PRIVATE_KEY);                    
                    if (strcmp($p_sApiKeyHash, $sHashDataKey) == 0)
                    {
                        return true;
                    }
                    else // we log it in the database
                    {
                        $oLogController = new CLogController();
                        $bInserted = $oLogController->insertLog("Key Hash client: ".$p_sApiKeyHash. " Key Hash server calculated: ".$sHashDataKey.
                                " url server: ".$sHeader
                                ,"CBaseapiController::authenticateAPI()", array());
                    }
                }
                else {
                    $oLogController = new CLogController();
                    $bInserted = $oLogController->insertLog("Public Key Problem. Server Public Key:".C_API_PUBLIC_KEY." Client Public Key: "
                            .$p_sApiKeyPub." url server: ".$sHeader
                            ,"CBaseapiController::authenticateAPI()", array());
                }

              
            }
        
        }
        catch(CException $e){
            throw $e;
        }

        return false;
    }


    
}
?>
