<?php


/**
 * Log Page controller.
 *
 * @author Nubesis
 */
class CLogController extends CAppController {

    public function CLogController() {
        $this->CAppController();
    }

    /**
     * This function inserts a log in the table Tablalogs with the error description
     * @param String $p_sMessage message with the error
     * @param String $p_sFile file where the error has produced
     */
    public function insertLog($p_sMessage, $p_sFile, $p_someTrace)
    {
        $bInserted = false;
        try {
            $dMoment = mktime();

            //we will have to see an special case for database connection.
            //if $p_sMessage has the error code 1046 and it has the words database connection then special error
            if ((stristr($p_sMessage,"1046")) && (stristr($p_sMessage,"database selected"))) {
                redirect( C_ERROR_VIEW . "/" .C_ERROR_CONNECTSQL );
                redirect( C_ERROR_VIEW . "/" .C_ERROR_CONNECTSQL);
            }


            if(defined('C_INSERT_ERROR_LOG'))
            {
                if(C_INSERT_ERROR_LOG != 0)
                {
                    $sTrace = "";

                  
                    if($p_someTrace != null)
                    {
                        foreach($p_someTrace as $oHashTrace)
                        {
                            $sTrace .= "******\n";
                            if(isset($oHashTrace['file']))
                                $sTrace .= "[file] => ".$oHashTrace['file']."\n";
                            if(isset($oHashTrace['line']))
                                $sTrace .= "[line] => ".$oHashTrace['line']."\n";
                            if(isset($oHashTrace['function']))
                                $sTrace .= "[function] => ".$oHashTrace['function']."\n";
                            if(isset($oHashTrace['class']))
                                $sTrace .= "[class] => ".$oHashTrace['class']."\n";
                            if(isset($oHashTrace['type']))
                                $sTrace .= "[type] => ".$oHashTrace['type']."\n";
                            if(isset($oHashTrace['args']))
                            {
                                $sTrace .= "[args] => \n";
                                foreach($oHashTrace['args'] as $sIndex => $sArg)
                                {
                                    if(!is_array($sArg) && !is_object($sArg))
                                        $sTrace .= "    [".$sIndex."] => ".$sArg."\n";
                                }
                            }
                        }
                    }                    

                    $sDateFormat = date("Y-m-d H:i:s",$dMoment);

                    $someInsert = array();
                    $someInsert['datetime'] = addslashes( $sDateFormat );
                    $someInsert['description'] = addslashes( $p_sMessage );
                    $someInsert['screen'] = addslashes( $p_sFile );
                    $someInsert['user'] = addslashes( 'test@test.com' );
                    $someInsert['trace'] = addslashes( $sTrace );
                    $someInsert['created'] = addslashes( $sDateFormat );
                    $someInsert['updated'] = addslashes( $sDateFormat );

                    $iReturnValue = $this->_oLog->insert($someInsert);

                    $oSession = new CAppSession();
                    $oSession->__set("id_error", $this->_oLog->get_iIdLastInserted());

                    //if we have an error inserting data values
                    if ($iReturnValue == C_ERROR_EXECSQL) {
                        redirect( C_ERROR_VIEW . "/" .C_ERROR_EXECSQL , $sTrace, C_ERROR_SESSION );
                    }
                    else { //it went ok
                        $bInserted = $p_someTrace;
                    }
                }
            }
            else
            {
                $sTrace = "";
                if($p_someTrace != null)
                {
                    foreach($p_someTrace as $oHashTrace)
                    {
                        $sTrace .= "******<br />";
                        if(isset($oHashTrace['file']))
                            $sTrace .= "[file] => ".$oHashTrace['file']."<br />";
                        if(isset($oHashTrace['line']))
                            $sTrace .= "[line] => ".$oHashTrace['line']."<br />";
                        if(isset($oHashTrace['function']))
                            $sTrace .= "[function] => ".$oHashTrace['function']."<br />";
                        if(isset($oHashTrace['class']))
                            $sTrace .= "[class] => ".$oHashTrace['class']."<br />";
                        if(isset($oHashTrace['type']))
                            $sTrace .= "[type] => ".$oHashTrace['type']."<br />";
                        if(isset($oHashTrace['args']))
                        {
                            $sTrace .= "[args] => <br />";
                            foreach($oHashTrace['args'] as $sIndex => $sArg)
                            {
                                if(!is_array($sArg) && !is_object($sArg))
                                    $sTrace .= "    [".$sIndex."] => ".$sArg."<br />";
                            }
                        }
                    }
                }
                redirect( C_ERROR_VIEW , $p_someTrace , C_ERROR_SESSION );
            }
        }
        catch(CException $e) {
            throw $e;

        }
        return $bInserted;
    }
}