<?php
/**
 * This file includes config.php, CController.php and CDispatcher.php which
 * are necessary files to initialize the application.
 * Also include the necessary paths of the important folders and files.
 * Indicates the debug level to know that errors show.
 * And Finally put the CORE_LOADED variable to 1 and strip the slashes from input data.
 *
 * @author Nubesis http://www.nubesis.com
 * @copyright Nubesis S.L.
 */

$someDictionary = array();

//App config
set_include_path(realpath(dirname(__FILE__) . '/../app/config/'));

require_once('app_config.php');

require_once('config.php');

require_once('CBaseIni.php');

require_once('classes/Basic.php');

if(file_exists('../app/bases/AppBasic.php'))
    require_once('../app/bases/AppBasic.php');

require_once('classes/CComponent.php');
require_once('classes/CConnectionManager.php');
require_once('classes/CController.php');
require_once('classes/CDispatcher.php');
require_once('classes/CException.php');
require_once('classes/CHelper.php');
require_once('classes/CModel.php');
require_once('classes/CView.php');
require_once('classes/CSession.php');

// Add application root, classes, models, controllers and views to the
// include path. Using this sentence will not have to do n require_onces for each file.
set_include_path(get_include_path() . PATH_SEPARATOR .
    implode(PATH_SEPARATOR, array(
        C_APP,
        C_LIBS,
        C_MODELS,
        C_PLUGINS,
        C_CONTROLLERS,
        C_COMPONENTS,
        C_VIEWS,
        C_ELEMENTS,
        C_HELPERS,
        C_DEFINES,
        C_ROUTES,
        C_LOCALES,
        C_APP_CONFIG,
        C_BKT_CONTROLLERS,
        C_BKT_MODELS,
        C_BKT_HELPERS,
        C_CORECLASSES
        )
    ));

// Set level of error reporting
if (C_DEBUG == 2) {
    error_reporting(E_ALL);
} elseif (C_DEBUG == 1) {
    error_reporting(E_ALL & ~E_NOTICE);
} else {
    error_reporting(E_ERROR | E_PARSE | E_USER_ERROR);
}

// Disable magic_quotes_runtime
//set_magic_quotes_runtime(0);
ini_set("magic_quotes_runtime", 0);

// Strip slashes from input
unescape($_GET);
unescape($_POST);
unescape($_COOKIE);
unescape($_SERVER);


// we include all available files in the app
//Core classes for reimplement in app
if(file_exists('../app/bases/CAppConnectionManager.php'))
    require_once('../app/bases/CAppConnectionManager.php');
else
    require_once('base/CAppConnectionManager.php');

if(file_exists('../app/bases/CAppController.php'))
    require_once('../app/bases/CAppController.php');
else
    require_once('base/CAppController.php');

if(file_exists('../app/bases/CAppDispatcher.php'))
    require_once('../app/bases/CAppDispatcher.php');
else
    require_once('base/CAppDispatcher.php');

if(file_exists('../app/bases/CAppException.php'))
    require_once('../app/bases/CAppException.php');
else
    require_once('base/CAppException.php');

if(file_exists('../app/bases/CAppHelper.php'))
    require_once('../app/bases/CAppHelper.php');
else
    require_once('base/CAppHelper.php');

if(file_exists('../app/bases/CAppModel.php'))
    require_once('../app/bases/CAppModel.php');
else
    require_once('base/CAppModel.php');

if(file_exists('../app/bases/CAppView.php'))
    require_once('../app/bases/CAppView.php');
else
    require_once('base/CAppView.php');

if(file_exists('../app/bases/CAppSession.php'))
    require_once('../app/bases/CAppSession.php');
else
    require_once('base/CAppSession.php');

//Core Controllers
require_once('controllers/CLogController.php');
require_once('controllers/CErrorController.php');
require_once('controllers/CBaseapiController.php');
require_once('controllers/CPageController.php');

//Core Models
require_once('models/CLog.php');
require_once('models/CApiKey.php');
//require_once('models/CSession.php');

//Defines
require_once('defines.php');

require_once('CAppIni.php');

// It tells to other cores that has been loaded
define('C_CORE_LOADED', 1);



/**
 * Perform stripslashes(simply scapes special chars with \) on an array or string if
 * get_magic_quotes_gpc(return a boolean value. It returns 1 if php is scaping by default
 * special chars, if returns 0 php is not scaping special chars) is set.
 *
 * @param $p_sValue A string or array to strip slashes from. The argument will
 * be passed as reference.
 */
function unescape($p_sValue) {
    if (get_magic_quotes_gpc()) {
        if (is_array($p_sValue)) {
            while (list($k, $v) = each($p_sValue)) {
                if (is_array($p_sValue[$k])) {
                    unescape($p_sValue[$k]);
                    @reset($p_sValue[$k]);
                } else {
                    $p_sValue[$k] = stripslashes($v);
                }
            }
        } else {
            $p_sValue = stripslashes($p_sValue);            
        }
    }    
}
?>