<?php
/**
 * Basic application controller that handles the common presentation.
 */
class CAjaxHelper extends CAppHelper {

    /**
     * This function returns javascript path.
     * @param <string> $p_sPath javascript path
     */
    public function js( $p_sPath , $p_bReturn = false , $p_bOnlyPath = false )
    {
        try {
            $sFinalPath = C_ROOT_KEY."js/".$p_sPath;

            if ( !$p_bOnlyPath )
            {
                if ( $p_bReturn )
                    return '<script type="text/javascript" src="' . $sFinalPath . '"></script>';
                else
                    echo '<script type="text/javascript" src="' . $sFinalPath . '"></script>';
            }
            else
            {
                if ( $p_bReturn )
                    return $sFinalPath;
                else
                    echo $sFinalPath;
            }
        }
        catch(CException $e) {
            throw $e;
        }
    }
    public function confirm( $P_sPath , $p_sMessage = "" , $p_sTitle = "Confirmation")
    {
        try {
            if($p_sMessage == "")
            {
                $p_sMessage = __("Are you sure that you want delete it?");
            }

            $sReturn = "onclick=\"";
            $sReturn .= "
                jConfirm('$p_sMessage','$p_sTitle',function(r) {
                    if (r==true) {
                        window.location='$P_sPath';
                    }
                    else {
                        return false;
                    }
                });
            ";
            $sReturn .= "\"";
        }
        catch(CException $e) {
            throw $e;
        }
        return $sReturn;
    }

    public function validate( $p_sModel = null , $p_sMethod = "*")
    {
        try {
            if ( !is_null( $p_sModel ) )
            {
                $sModel = basename( $p_sModel );
                $oModel = new $sModel();

                $someValidators = $oModel->get_someAjaxValidators();

                $sReturn = "<script type=\"text/javascript\">
                                $(document).ready(function(){";

                if( isset( $someValidators["*"] ) )
                {
                    foreach ( $someValidators["*"] as $index => $validator )
                    {
                        $sId = fieldToId( $index , "id".substr($p_sModel, 1));

                        foreach ($validator as $function => $data) {
                            $sReturn .= "
                                $('#$sId').blur(function(){
                                    var someArray = new Array();";
                            foreach ($data as $key => $value) {
                                $sReturn .= "
                                        someArray[\"$key\"] = \"$value\";
                                ";
                            }

                            $sReturn .= "
                                    $function(\"$sId\",someArray);
                                });
                            ";
                        }
                    }
                }
                
                if ( $p_sMethod != "*" )
                {
                    if( isset( $someValidators[ $p_sMethod ] ) )
                    {
                        foreach ( $someValidators[$p_sMethod] as $index => $validator )
                        {
                            $sId = fieldToId( $index , "id".substr($p_sModel, 1)."s" );

                            foreach ($validator as $function => $data) {
                                $sReturn .= "
                                    $('#$sId').blur(function(){
                                        var someArray = new Array();";
                                foreach ($data as $key => $value) {
                                    $sReturn .= "
                                            someArray[\"$key\"] = \"$value\";
                                    ";
                                }

                                $sReturn .= "
                                        $function(\"$sId\",someArray);
                                    });
                                ";
                            }
                        }
                    }
                }

                $sReturn .= "   });
                            </script>";
            }
        }
        catch(CException $e) {
            throw $e;
        }
        return $sReturn;
    }

    public function helpSidebar()
    {
        try {
            $oHtml = $this->_oView->get('oHtml');            
            ob_start();
            include("helperSidebar.php");
            $sContent = ob_get_contents();
            ob_end_clean();
        }
        catch(CException $e) {
            throw $e;
        }
        return $sContent;
    }

    public function addHelpSidebarMessage( $p_sHeader , $p_sController = "" , $p_sMethod = "" , $p_bImage = false )
    {
        try {
            $oHtml = $this->_oView->get("oHtml");

            $sReturn = "";
            if( ! $p_bImage )
            {
                $sReturn .= "<script type='text/javascript'>$(document).ready(function(){ addHelpMessage(\"".$p_sHeader."\" , \"".md5($p_sHeader)."\" , \"" . $p_sController . "\" , \"" . $p_sMethod . "\"); }); </script>";
            }
            else
            {
                $sReturn .= "<script type='text/javascript'>$(document).ready(function(){ addHelpMessage(\"".$p_sHeader."\" , \"".md5($p_sHeader)."\" , \"" . $p_sController . "\" , \"" . $p_sMethod . "\"); }); </script>";
                $someOnEvents['onclick'] = "highlightMessage( \"".md5($p_sHeader)."\");";
                $sReturn .= $oHtml->image( array( 'src' => 'global/icon-info.png' , 'title' => '' , 'alt' => '' , 'someOnEvents' => $someOnEvents , 'class' => 'clsInfoButton' ) );
            }
        }
        catch(CException $e) {
            throw $e;
        }
        return $sReturn;
    }

    public function message( $p_sTextMessage , $p_sTypeMessage )
    {
        try {
            $oHtml = $this->_oView->get('oHtml');
            ob_start();
            include("helperMessage.php");
            $sContent = ob_get_contents();
            ob_end_clean();
        }
        catch(CException $e) {
            throw $e;
        }
        return $sContent;
    }
    /**
    * This function creates a component to upload images easily. To use it you can use a helper in your
    * view with the next command: echo $oAjax->upload(null, "users", "image", "id", 100, "");
    * @param <type> $p_iId the magic id :P Fuck you
    * @param <type> $p_sTable the name of the table that will store the
    * @param <type> $p_sField the name of the field in the database with the path where will be stored/loaded the image
    * @param <type> $p_sIdField the identifier field in the database
    * @param <type> $p_iWidth the size of the image in pixels
    * @param <type> $p_sSrc Path of the image to be loaded by default.
    * @param <type> $p_sType The type of the file that we are uploading "image" or  "file"
    * @param <type> $p_sPath The path of the container of all the images in your server
    * @param <type> $p_sJavascriptCallback The name of function in Javascript that will be called when return from the ajax call
    * @return <type> It return an String with the javascript and html that will be uploaded in your view
    */

    public function upload( $p_iId = null, $p_sTable = "users", $p_sField = "photo", $p_sIdField = "id", $p_iWidth = 0 , $p_sSrc = "", $p_sType = "image", $p_sPath = "uploads/", $p_sJavascriptCallback = "")
    {
        try {
            $oHtml = $this->_oView->get('oHtml');
            ob_start();
            include("helperUpload.php");
            $sContent = ob_get_contents();
            ob_end_clean();
        }
        catch(CException $e) {
            throw $e;
        }
        return $sContent;
    }
}
?>