<?php
/**
 * Basic application controller that handles the common presentation.
 */
class CHtmlHelper extends CAppHelper {

    /**
     * This function returns render input tag.
     * @param <array> $p_someValues
     */
    public function input( $p_sFieldName , $p_someValues , $p_bReturn = false)
    {
        try
        {
            $accept = "";$align = "";$alt = "";$checked = "";$disabled = "";
            $maxlength = "";$name = "";$readonly = "";$size = "";$src = "";
            $type = "";$value = "";$accesskey = "";$class = "";$dir = "";
            $id = "";$lang = "";$style = "";$tabindex = "";$title = "";
            $someOnEvents = array();

            extract($p_someValues);

            $sPrintAccept = "";$sPrintAlign = "";$sPrintAlt = "";$sPrintChecked = "";
            $sPrintDisabled = "";$sPrintMaxlength = "";$sPrintName = "";
            $sPrintReadonly = "";$sPrintSize = "";$sPrintSrc = "";$sPrintType = "";
            $sPrintValue = "";$sPrintAccesskey = "";$sPrintClass = "";$sPrintDir = "";
            $sPrintId = "";$sPrintLang = "";$sPrintStyle = "";$sPrintTabindex = "";
            $sPrintTitle = "";$sPrintOnEvents = "";

            //Get field name value
            if( empty ( $value ) )
            {
                if( !empty($name))
                {
                    $someName = explode ("data[", $name);
                    $someName2 = explode("]", $someName[1]);
                    $value = $this->_oView->issetField( $p_sFieldName , $someName2[0] );
                }
                else
                    $value = $this->_oView->issetField( $p_sFieldName );
            }

            if( !empty ( $accept ) ){$sPrintAccept = "accept='$accept'";}
            if( !empty ( $align ) ){$sPrintAlign = "align='$align'";}
            if( !empty ( $alt ) ){$sPrintAlt = "alt='$sAlt'";}
            if( !empty ( $checked ) ){$sPrintChecked = "checked='$checked'";}
            if( !empty ( $disabled ) ){$sPrintDisabled = "disabled='$disabled'";}
            if( !empty ( $maxlength ) ){$sPrintMaxlength = "maxlength='$maxlength'";}
            if( !empty ( $name ) ){$sPrintName = "name='$name'";}
            if( !empty ( $readonly ) ){$sPrintReadonly = "readonly='$readonly'";}
            if( !empty ( $size ) ){$sPrintSize = "size='$size'";}
            if( !empty ( $src ) ){$sPrintSrc = "src='$src'";}
            if( !empty ( $type ) ){$sPrintType = "type='$type'";}
            $sPrintValue = "value='$value'";
            if( !empty ( $accesskey ) ){$sPrintAccesskey = "accesskey='$accesskey'";}
            if( !empty ( $class ) ){$sPrintClass = "class='$class'";}
            if( !empty ( $dir ) ){$sPrintDir = "dir='$dir'";}
            if( !empty ( $id ) ){$sPrintId = "id='$id'";}
            if( !empty ( $lang ) ){$sPrintLang = "lang='$lang'";}
            if( !empty ( $style ) ){$sPrintStyle = "style='$style'";}
            if( !empty ( $tabindex ) ){$sPrintTabindex = "tabindex='$tabindex'";}
            if( !empty ( $title ) ){$sPrintTitle = "title='$title'";}

            if( !empty ( $someOnEvents ) )
            {
                foreach ( $someOnEvents as $sIndexEvents => $sEvent )
                {
                    $sPrintOnEvents .= "$sIndexEvents='$sEvent' ";
                }
            }

            $sPrintInput = "<input $sPrintAccept $sPrintAlign $sPrintAlt $sPrintChecked $sPrintDisabled $sPrintMaxlength $sPrintName $sPrintReadonly $sPrintSize $sPrintSrc $sPrintType $sPrintValue $sPrintAccesskey $sPrintClass $sPrintDir $sPrintId $sPrintLang $sPrintStyle $sPrintTabindex $sPrintTitle $sPrintOnEvents />";

            $someErrorMessages = $this->_oLayout->get("someErrorMessages");
            if( $someErrorMessages != "")
            {
                if( isset( $someErrorMessages[$p_sFieldName] ) )
                {
                    $sPrintInput .= "<div id='".$id."Message' class='clsLbError' >$someErrorMessages[$p_sFieldName]</div>";
                }
            }

            if ( !$p_bReturn )
                echo $sPrintInput;
            else
                return $sPrintInput;
            
        }
        catch(CException $e)
        {
            throw $e;
        }
    }

    /**
     * This function returns a tag html <img src="" ... with the values passed by parameter
     * @param <array> $p_someValues this parameter must be passed with below format:
     *
     * (sPrintSrc => "footer/image.png",
     * sPrintWidth => "300",
     * sPrintStyle => "",
     * sPrintClass =>"the name of the class of css",
     * sPrintId => "the id of the tag img"
     * sPrintOnEvents => array(onclick => event(), onblur => event))
     *
     * @param <boolean> $p_bReturn if this parameter is true it will return an string, else it will execute an echo sentence
     * @param <boolean> if it's true it will return only a simple path. It could be combined with an html <img> tag. You don't need
     * to pass an array it could be a simple String.
     *
     *
     */
    function image( $p_someValues , $p_bReturn = false , $p_bOnlyPath = false , $p_bAbsolutePath = false )
    {
        try
        {
            $sSeed = "";
            if(!$p_bAbsolutePath)
                $sSeed = C_ROOT_KEY."images/";

            if(!$p_bOnlyPath)
            {
                $src = "";$alt = "";$title = "";
                $width = "";$class = "";$id = "";
                $style = "";$someOnEvents = array();

                extract($p_someValues);

                $sPrintSrc = "";$sPrintAlt = "";$sPrintTitle = "";
                $sPrintWidth = "";$sPrintClass = "";$sPrintId = "";
                $sPrintStyle = "";$sPrintOnEvents = "";

                if( !empty ( $src ) ){$sPath = $sSeed.$src;$sPrintSrc = "src='$sPath'";}
                if( !empty ( $alt ) ){$sPrintAlt = "alt='$alt'";}
                if( !empty ( $title ) ){$sPrintTitle = "title='$title'";}
                if( !empty ( $width ) ){$sPrintWidth = "width='$width'";}
                if( !empty ( $class ) ){$sPrintClass = "class='$class'";}
                if( !empty ( $id ) ){$sPrintId = "id='$id'";}
                if( !empty ( $style ) ){$sPrintStyle = "style='$style'";}
                if( !empty ( $someOnEvents ) ){
                    foreach ( $someOnEvents as $sIndexEvents => $sEvent )
                    {
                        $sPrintOnEvents .= "$sIndexEvents='$sEvent' ";
                    }
                }

                $sPrintImg = "<img $sPrintSrc $sPrintAlt $sPrintTitle $sPrintWidth $sPrintClass $sPrintId $sPrintStyle $sPrintOnEvents />";

                if ( !$p_bReturn )
                    echo $sPrintImg;
                else
                    return $sPrintImg;
            }
            else
            {
               if(!$p_bReturn)
                    echo $sSeed.$p_someValues;
                else
                    return $sSeed.$p_someValues;
            }
        }
        catch(CException $e)
        {
            throw $e;
        }
    }

    /**
     * This function creates a link in the an href tag.
     * @param <type> $p_sView It's the view where will which will be used in the link
     * @param <type> $p_sController It's the controller which will be used in the link
     * @param <type> $p_sLanguageCustom It's the language which will be created the link
     * @return <type> it returns a url text
     */
    public function link($p_sView = '' , $p_sController = null, $p_sLanguageCustom = "", $p_bAbsoluteUrl = false)
    {
        try {
            if( defined ( 'C_ENCRYPT' ) && C_ENCRYPT == 1 )
            {
                $oSession = new CAppSession();
                if (($p_sController == "widgets") || ($p_sController == "widgetsjs") || ($p_sController == "csvs"))
                {
                    if ($p_bAbsoluteUrl == false) {
                        if ($p_sLanguageCustom == "") {
                            return C_ROOT_KEY.$this->_oView->showParentUrl($p_sController).$p_sView;
                        }
                        else {
                            return C_ROOT_KEY.$this->_oView->showParentUrlLanguage($p_sLanguageCustom, $p_sController).$p_sView;
                        }
                    }
                    else
                    {
                        if ($p_sLanguageCustom == "") {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$this->_oView->showParentUrl($p_sController).$p_sView;
                        }
                        else {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$this->_oView->showParentUrlLanguage($p_sLanguageCustom, $p_sController).$p_sView;
                        }
                    }
                }
                
                if($p_sController == "pages")
                {
                    if ($p_bAbsoluteUrl == false) {
                        if ($p_sLanguageCustom == "") {
                            return C_ROOT_KEY.$oSession->encrypt( $p_sView );
                        }
                        else {
                            return C_ROOT_KEY.$oSession->encrypt( $p_sView );
                        }
                    }
                    else {
                        if ($p_sLanguageCustom == "") {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$oSession->encrypt( $p_sView );
                        }
                        else {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$oSession->encrypt( $p_sView );
                        }
                    }
                }
                else
                {
                    if ($p_bAbsoluteUrl == false) {
                        if ($p_sLanguageCustom == "") {
                            return C_ROOT_KEY.$oSession->encrypt($this->_oView->showParentUrl($p_sController).$p_sView);
                        }
                        else {
                            return C_ROOT_KEY.$oSession->encrypt($this->_oView->showParentUrlLanguage($p_sLanguageCustom, $p_sController).$p_sView);
                        }
                    }
                    else {
                        if ($p_sLanguageCustom == "") {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$oSession->encrypt($this->_oView->showParentUrl($p_sController).$p_sView);
                        }
                        else {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$oSession->encrypt($this->_oView->showParentUrlLanguage($p_sLanguageCustom, $p_sController).$p_sView);
                        }
                    }
                }
            }
            else
            {
                if($p_sController == "pages")
                {
                    if ($p_bAbsoluteUrl == false) {
                        if ($p_sLanguageCustom == "") {
                            return C_ROOT_KEY.$p_sView;
                        }
                        else {
                            return C_ROOT_KEY.$p_sView;
                        }
                    }
                    else {
                        if ($p_sLanguageCustom == "") {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$p_sView;
                        }
                        else {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$p_sView;
                        }
                    }
                }
                else
                {
                    if ($p_bAbsoluteUrl == false) {
                        if ($p_sLanguageCustom == "") {
                            return C_ROOT_KEY.$this->_oView->showParentUrl($p_sController).$p_sView;
                        }
                        else {
                            return C_ROOT_KEY.$this->_oView->showParentUrlLanguage($p_sLanguageCustom, $p_sController).$p_sView;
                        }
                    }
                    else {
                        if ($p_sLanguageCustom == "") {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$this->_oView->showParentUrl($p_sController).$p_sView;
                        }
                        else {
                            return C_WIDGET_PROTOCOL.'://'.C_ROOT_DOMAIN.C_ROOT_KEY.$this->_oView->showParentUrlLanguage($p_sLanguageCustom, $p_sController).$p_sView;
                        }
                    }
                }
            }
        }
        catch(CException $e) {
            throw $e;
        }
    }

    /**
     * This function returns css path.
     * @param <string> $p_sPath css path
     */
    function css($p_sPath, $p_sAddText=null)
    {
        try {
            $sBrowser = "";

            if(isset ($_SERVER['HTTP_USER_AGENT'])){
                $sBrowser = $this->getBrowser($_SERVER['HTTP_USER_AGENT']);
            }
            else{
                $sBrowser = "ff";
            }
            
            if ($p_sAddText == null)
            {
                echo "<link href=\"" . C_ROOT_KEY."css/".$p_sPath . "\" rel=\"stylesheet\" type=\"text/css\" />\n";
            }
            else
            {
                echo "<link href=\"" . C_ROOT_KEY."css/".$p_sPath . "\" rel=\"stylesheet\" type=\"text/css\" $p_sAddText />\n";
            }

            $p_sPath = explode('.css' , $p_sPath);

            $sCssFile = C_ROOT.DIRECTORY_SEPARATOR."public".DIRECTORY_SEPARATOR."css".DIRECTORY_SEPARATOR.$p_sPath[0].$sBrowser.".css";

            if (file_exists( $sCssFile ) )
            {
                if ($p_sAddText == null)
                {
                    echo "<link href=\"" . C_ROOT_KEY."css/".$p_sPath[0].$sBrowser.".css" . "\" rel=\"stylesheet\" type=\"text/css\" />";
                }
                else
                {
                    echo "<link href=\"" . C_ROOT_KEY."css/".$p_sPath[0].$sBrowser.".css" . "\" rel=\"stylesheet\" type=\"text/css\" $p_sAddText />";
                }
            }
        }
        catch(CException $e) {
            throw $e;
        }
        return true;
    }

    /**
     *
     * @param <type>
     * @return <type>
     *
     * 'op' => 'Opera',
     * 'ff' => 'Mozilla Firefox',
     * 'gl' => 'Galeon',
     * 'gk' => 'Gecko',
     * 'myie' => 'MyIE',
     * 'lx' => 'Lynx',
     * 'nts' => 'Netscape',
     * 'kr' => 'Konqueror',
     * 'ie9' => 'Internet Explorer 9',
     * 'ie8' => 'Internet Explorer 8',
     * 'ie7' => 'Internet Explorer 7',
     * 'ie6' => 'Internet Explorer 6',
     * 'ie5' => 'Internet Explorer 5',
     * 'ie4' => 'Internet Explorer 4'
     */
    function getBrowser($p_sUserAgent)
    {
        try {
             $sBrowsers = array(
                  'op' => 'Opera',
                  'ff'=> '(Firebird)|(Firefox)',
                  'gl' => 'Galeon',
                  'gk'=>'Gecko',
                  'myie'=>'MyIE',
                  'lx' => 'Lynx',
                  'nts' => '(Mozilla\/4\.75)|(Netscape6)|(Mozilla\/4\.08)|(Mozilla\/4\.5)|(Mozilla\/4\.6)|(Mozilla\/4\.79)',
                  'kr'=>'Konqueror',
                  'ie9' => '(MSIE 9\.[0-9]+)',
                  'ie8' => '(MSIE 8\.[0-9]+)',
                  'ie7' => '(MSIE 7\.[0-9]+)',
                  'ie6' => '(MSIE 6\.[0-9]+)',
                  'ie5' => '(MSIE 5\.[0-9]+)',
                  'ie4' => '(MSIE 4\.[0-9]+)',
            );

            foreach($sBrowsers as $sIndexBrowser => $sContentBrowser)
            {
               if (preg_match('/'.$sContentBrowser.'/', $p_sUserAgent))
                   return $sIndexBrowser;
            }
        }
        catch(CException $e) {
            throw $e;
        }

        return '';
    }

    function getCancelUrl( $bJavascript = true ) {
        try {
            $oSession = new CAppSession();

            $someBread = $oSession->__getArray("breadcrumb");
            $somePrev = end( $someBread );
            $somePrev = prev( $someBread );

            $sLink = $this->link( $somePrev["view"] , $somePrev["controller"] );

            if($bJavascript)
                $sLink = "javascript: window.location=\"".$sLink."\"";
        }
        catch(CException $e) {
            throw $e;
        }

        return $sLink;
    }

}
?>