<?php
/**
 * Basic application controller that handles the common presentation.
 */
class CPaginatorHelper extends CAppHelper {

    public function sort($p_sColumn, $p_sTitle = null)
    {
        $sReturn = "";

        try{
            $oHtml = $this->_oView->get("oHtml");
            $sGetColumn = "";
            $sGetDirection = "";
            $sDirection = "asc";

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^sort/', $sGet))
                {
                    $someSort = explode(':', $sGet);
                    $sGetColumn = $someSort[1];
                }

                if(preg_match('/^direction/', $sGet))
                {
                    $someDirection = explode(':', $sGet);
                    $sGetDirection = $someDirection[1];
                }

            endforeach;

            if($sGetColumn == $p_sColumn)
            {
                if ($sGetDirection == 'asc')
                    $sDirection = 'desc';
            }
            if($p_sTitle == null)
                $p_sTitle = $p_sColumn;

            $sLink = $oHtml->link($this->_oView->get_sView()."/page:1/sort:$p_sColumn/direction:$sDirection");

            $sReturn = "<a href='$sLink' title='$p_sTitle'>$p_sTitle</a>";

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }

    public function next( $p_oView = 'Next' , $p_sImage = null)
    {
        $sReturn = "";

        try{
            $oHtml = $this->_oView->get("oHtml");
            $sGetColumn = "";
            $sGetDirection = "";
            $sPage = 1;
            $sContent = "";

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^page/', $sGet))
                {
                    $somePage = explode(':', $sGet);
                    $sPage = ($somePage[1] + 1);
                }

                if(preg_match('/^sort/', $sGet))
                {
                    $someSort = explode(':', $sGet);
                    $sGetColumn = "/sort:$someSort[1]";
                }

                if(preg_match('/^direction/', $sGet))
                {
                    $someDirection = explode(':', $sGet);
                    $sGetDirection = "/direction:$someDirection[1]";
                }

            endforeach;

            if($sPage == 1)
                $sPage = 2;

            if($p_sImage == null)
                $sContent = $p_oView;
            else
                $sContent = $p_sImage;

            $sLink = $oHtml->link($this->_oView->get_sView()."/page:$sPage$sGetColumn$sGetDirection");

            $iMaxPage = $this->_oView->get( "iMaxPage" , 0 );

            if(($sPage - 1) < $iMaxPage)
                $sReturn = "<a href='$sLink' title='$p_oView'>$sContent</a>";
            else
                $sReturn = "";

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }

    public function last( $p_oView = 'Next' , $p_sImage = null)
    {
        $sReturn = "&nbsp;";

        try{
            $oHtml = $this->_oView->get("oHtml");
            $sGetColumn = "";
            $sGetDirection = "";
            $sPage = 1;
            $sContent = "";

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^page/', $sGet))
                {
                    $somePage = explode(':', $sGet);
                    $sPage = ($somePage[1] + 1);
                }

                if(preg_match('/^sort/', $sGet))
                {
                    $someSort = explode(':', $sGet);
                    $sGetColumn = "/sort:$someSort[1]";
                }

                if(preg_match('/^direction/', $sGet))
                {
                    $someDirection = explode(':', $sGet);
                    $sGetDirection = "/direction:$someDirection[1]";
                }

            endforeach;

            if($sPage == 1)
                $sPage = 2;

            if($p_sImage == null)
                $sContent = $p_oView;
            else
                $sContent = $p_sImage;

            $sLast = $this->_oView->get( "iMaxPage" , 0 );
            $sLink = $oHtml->link($this->_oView->get_sView()."/page:$sLast$sGetColumn$sGetDirection");

            $iMaxPage = $this->_oView->get( "iMaxPage" , 0 );

            if(($sPage - 1) < $iMaxPage)
                $sReturn = "<a href='$sLink' title='$p_oView'>$sContent</a>";
            else
                $sReturn = "&nbsp;";

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }

    public function prev( $p_oView = 'Previous' , $p_sImage = null)
    {
        $sReturn = "";

        try{
            $oHtml = $this->_oView->get("oHtml");
            $sGetColumn = "";
            $sGetDirection = "";
            $sPage = 0;
            $sContent = "";

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^page/', $sGet))
                {
                    $somePage = explode(':', $sGet);
                    $sPage = ($somePage[1] - 1);
                }

                if(preg_match('/^sort/', $sGet))
                {
                    $someSort = explode(':', $sGet);
                    $sGetColumn = "/sort:$someSort[1]";
                }

                if(preg_match('/^direction/', $sGet))
                {
                    $someDirection = explode(':', $sGet);
                    $sGetDirection = "/direction:$someDirection[1]";
                }

            endforeach;

            if($p_sImage == null)
                $sContent = $p_oView;
            else
                $sContent = $p_sImage;

            $sLink = $oHtml->link($this->_oView->get_sView()."/page:$sPage$sGetColumn$sGetDirection");

            if($sPage > 0)
            {
                $sReturn = "<a href='$sLink' title='$p_oView'>$sContent</a>";
            }
            else
            {
                $sReturn = "";
            }

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }

    public function first( $p_oView = 'Previous' , $p_sImage = null)
    {
        $sReturn = "&nbsp;";

        try{
            $oHtml = $this->_oView->get("oHtml");
            $sGetColumn = "";
            $sGetDirection = "";
            $sPage = 0;
            $sContent = "";

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^page/', $sGet))
                {
                    $somePage = explode(':', $sGet);
                    $sPage = ($somePage[1] - 1);
                }

                if(preg_match('/^sort/', $sGet))
                {
                    $someSort = explode(':', $sGet);
                    $sGetColumn = "/sort:$someSort[1]";
                }

                if(preg_match('/^direction/', $sGet))
                {
                    $someDirection = explode(':', $sGet);
                    $sGetDirection = "/direction:$someDirection[1]";
                }

            endforeach;

            if($p_sImage == null)
                $sContent = $p_oView;
            else
                $sContent = $p_sImage;

            $sLink = $oHtml->link($this->_oView->get_sView()."/page:1$sGetColumn$sGetDirection");

            if($sPage > 0)
            {
                $sReturn = "<a href='$sLink' title='$p_oView'>$sContent</a>";
            }
            else
            {
                $sReturn = "&nbsp;";
            }

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }

    public function go( $p_sPage = 0 , $p_sImage = null )
    {
        $sReturn = "";

        try{
            $oHtml = $this->_oView->get("oHtml");
            $sGetColumn = "";
            $sGetDirection = "";
            $sPage = $p_sPage;
            $sContent = "";

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^sort/', $sGet))
                {
                    $someSort = explode(':', $sGet);
                    $sGetColumn = "/sort:$someSort[1]";
                }

                if(preg_match('/^direction/', $sGet))
                {
                    $someDirection = explode(':', $sGet);
                    $sGetDirection = "/direction:$someDirection[1]";
                }

            endforeach;

            if($p_sImage == null)
                $sContent = $p_sPage;
            else
                $sContent = $p_sImage;

            $sLink = $oHtml->link($this->_oView->get_sView()."/page:$sPage$sGetColumn$sGetDirection");

            $sReturn = "<a href='$sLink' title='$p_sPage'>$sContent</a>";

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }

    public function counter( $p_oMessage )
    {
        $sReturn = "";

        try{

            $sPage = 0;
            $iPage = 0;
            $iPages = 0;
            $sReturn = "";
            $iCurrent = 0;
            $iCount = 0;
            $iStart = 0;
            $iEnd = 0;

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^page/', $sGet))
                {
                    $somePage = explode(':', $sGet);
                    $sPage = ($somePage[1] - 1);
                }

            endforeach;

            if($sPage > 0)
            {
                $iPage = $sPage + 1;
            }

            $iPages = $this->_oView->get( "iMaxPage" , 0 );

            $iCurrent = $this->_oView->get( "iLimit" , 0 );

            $iCount = $this->_oView->get( "iTotalRows" , 0 );

            $iStart = $iCurrent*$sPage;

            $iEnd = 0;

            if ( ( $iStart + $iCurrent ) > $iCount )
            {
                $iEnd = $iCount;
            }
            else
            {
                $iEnd = $iStart + $iCurrent;
            }

            $iStart ++;

            if($sPage == 0)
            {
                $iPage = 1;
            }

            $somePatterns = array();
            $somePatterns[0] = '/%page%/';
            $somePatterns[1] = '/%pages%/';
            $somePatterns[2] = '/%current%/';
            $somePatterns[3] = '/%count%/';
            $somePatterns[4] = '/%start%/';
            $somePatterns[5] = '/%end%/';

            $someReplacements = array();
            $someReplacements[0] = $iPage;
            $someReplacements[1] = $iPages;
            $someReplacements[2] = $iCurrent;
            $someReplacements[3] = $iCount;
            $someReplacements[4] = $iStart;
            $someReplacements[5] = $iEnd;

            $sReturn = preg_replace($somePatterns, $someReplacements, $p_oMessage);

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }
    public function numberedPage()
    {
        $sReturn = "";

        try{

            $sPage = 1;
            $iPages = 0;

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^page/', $sGet))
                {
                    $somePage = explode(':', $sGet);
                    $sPage = ($somePage[1]);
                }

            endforeach;

            $iPages = $this->_oView->get( "iMaxPage" , 0 );

            for ( $i = 1 ; $i <= $iPages ; $i++ )
            {
                if( $i == $sPage )
                    $sReturn .= "<span class='clsPageSelected'>" . $this->go($i). "</span>";
                else
                    $sReturn .= "<span class='clsNumberedPage'>" . $this->go($i). "</span>";
            }
        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }

    public function printPaginate( $p_sReplace , $p_sView , $p_oView = 'Print' , $p_sImage = null)
    {
        $sReturn = "";

        try{
            $oHtml = $this->_oView->get("oHtml");
            $sGetColumn = "";
            $sGetDirection = "";
            $sPage = 1;
            $sContent = "";

            //Select paginator variables
            foreach ($_GET as $sGet):

                if(preg_match('/^sort/', $sGet))
                {
                    $someSort = explode(':', $sGet);
                    $sGetColumn = "/sort:$someSort[1]";
                }

                if(preg_match('/^direction/', $sGet))
                {
                    $someDirection = explode(':', $sGet);
                    $sGetDirection = "/direction:$someDirection[1]";
                }

            endforeach;

            if($p_sImage == null)
                $sContent = $p_oView;
            else
                $sContent = "<img alt='$p_oView' src='$p_sImage' />";

            $sPath = str_replace($p_sReplace, $p_sView, $oHtml->link($this->_oView->get_sView()));

            $sLink = "$sPath$sGetColumn$sGetDirection";

            $sReturn = "<a href='$sLink' title='$p_oView' target='_blank'>$sContent</a>";

        }catch(CException $e) {
            //redirects to CErrorPage
            throw $e;
       }

       return $sReturn;
    }
    
}
?>