<?php
require_once '../../../core.php';
require_once 'PHPUnit/Framework.php';

require_once dirname(__FILE__).'/../../../classes/CDispatcher.php';

/**
 * Test class for CDispatcher.
 * Generated by PHPUnit on 2010-04-16 at 14:18:26.
 */
class CDispatcherTest extends PHPUnit_Framework_TestCase {
    /**
     * @var CDispatcher
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
        $this->object = new CDispatcher;
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {
    }

    /**
     * Generated from @assert (C_ROOT_KEY."saasdfpi/") == true.
     */
    public function testDispatch() {
        $_SERVER['REQUEST_METHOD'] = "GET";
        $this->assertTrue(
                $this->object->dispatch(C_ROOT_KEY."saasdfpi/")
        );
    }

    /**
     * Generated from @assert ("asdasdfasdf") == false.
     */
    public function testDispatch2() {
        $this->assertFalse(
                $this->object->dispatch("asdasdfasdf")
        );
    }

    /**
     * Generated from @assert ("") == false.
     */
    public function testDispatch3() {
        $this->assertFalse(
                $this->object->dispatch("")
        );
    }

    /**
     * Generated from @assert (null) == false.
     */
    public function testDispatch4() {
        $this->assertFalse(
                $this->object->dispatch(null)
        );
    }

    /**
     * Generated from @assert ("parama",array()) == C_ERROR_CONTROLLERNOTDEFINED.
     */
    public function testCall() {
        $this->assertEquals(
                C_ERROR_CONTROLLERNOTDEFINED,
                $this->object->call("parama",array())
        );
    }

    /**
     * Generated from @assert ("parama/",array("controller" => "Mainpages")) == true.
     */
    public function testCall2() {
        $_SERVER['REQUEST_METHOD'] = "GET";
        $this->assertTrue(
                $this->object->call("parama/",array("controller" => "Mainpages"))
        );
    }

    /**
     * Generated from @assert ("",array()) == C_ERROR_CONTROLLERNOTDEFINED.
     */
    public function testCall3() {
        $this->assertEquals(
                C_ERROR_CONTROLLERNOTDEFINED     ,
                $this->object->call("",array())
        );
    }

    /**
     * Generated from @assert ("",C_ROOT_KEY."es/value") == false.
     */
    public function testMatchLanguageString() {
        $this->assertFalse(
                $this->object->matchLanguageString("",C_ROOT_KEY."es/value")
        );
    }

    /**
     * Generated from @assert ("es",C_ROOT_KEY."es/value") == true.
     */
    public function testMatchLanguageString2() {
        $this->assertTrue(
                $this->object->matchLanguageString("es",C_ROOT_KEY."es/value")
        );
    }

    /**
     * Generated from @assert ("en",C_ROOT_KEY."es/value") == false.
     */
    public function testMatchLanguageString3() {
        $this->assertFalse(
                $this->object->matchLanguageString("en",C_ROOT_KEY."es/value")
        );
    }

    /**
     * Generated from @assert ("notexists") == "notexists".
     */
    public function testCheckPages() {
        $this->assertEquals(
                "notexists",
                $this->object->checkPages("notexists")
        );
    }
}
?>
