(function( $ ) {
        $.widget( "ui.combobox", {
		click: function(){
			// trigger beforeopen event.  if beforeopen returns false,
			// prevent bail out of this method.
			if( this._trigger("beforeclick") === false ){
				return;
			}
			// more open related code here

			// trigger open event
			this._trigger("click");

			return this;
		},
                _create: function() {
                        var self = this,
                                self_id = $(this.element).attr("id"),
                                select = this.element.hide(),
                                selected = select.children( ":selected" ),
                                value = selected.val() ? selected.text() : "";
                        var input = $( "<input>" )
                                .insertAfter( select )
                                .attr("id", self_id + "-ui")
                                .val( value )
                                .autocomplete({
                                        delay: 0,
                                        minLength: 0,
                                        source: function( request, response ) {
                                                var matcher = new RegExp( $.ui.autocomplete.escapeRegex(request.term), "i" );
                                                response( select.children( "option" ).map(function() {
                                                        var text = $( this ).text();
                                                        if ( this.value && ( !request.term || matcher.test(text) ) )
                                                                return {
                                                                        label: text.replace(
                                                                                new RegExp(
                                                                                        "(?![^&;]+;)(?!<[^<>]*)(" +
                                                                                        $.ui.autocomplete.escapeRegex(request.term) +
                                                                                        ")(?![^<>]*>)(?![^&;]+;)", "gi"
                                                                                ), "<strong>$1</strong>" ),
                                                                        value: text,
                                                                        option: this
                                                                };
                                                }) );
                                        },
                                        select: function( event, ui ) {
                                                ui.item.option.selected = true;
                                                self._trigger( "selected", event, {
                                                        item: ui.item.option
                                                });
                                                self.click();
                                        },
                                        change: function( event, ui ) {
                                                if ( !ui.item ) {
                                                        var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( $(this).val() ) + "$", "i" ),
                                                                valid = false;
                                                        select.children( "option" ).each(function() {
                                                                if ( this.value.match( matcher ) ) {
                                                                        this.selected = valid = true;
                                                                        return false;
                                                                }
                                                        });
                                                }
                                        }
                                }).addClass( "ui-combo-input" );

                        input.data( "autocomplete" )._renderItem = function( ul, item ) {
                                return $( "<li></li>" )
                                        .data( "item.autocomplete", item )
                                        .append( "<a>" + item.label + "</a>" )
                                        .appendTo( ul );
                        };

                        $( "<button type='button'>&nbsp;</button>" )
                                .attr( "tabIndex", -1 )
                                .attr( "title", "Show All Items" )
                                .insertAfter( input )
                                .button({
                                        icons: {
                                                primary: "ui-icon-triangle-1-s"
                                        },
                                        text: false
                                })
                                .removeClass( "ui-corner-all" )
                                .addClass( "ui-corner-right ui-button-icon ui-combo-button" )
                                .click(function() {
                                        // close if already visible
                                        if ( input.autocomplete( "widget" ).is( ":visible" ) ) {
                                                input.autocomplete( "close" );
                                                return;
                                        }

                                        // pass empty string as value to search for, displaying all results
                                        input.autocomplete( "search", "" );
                                        input.focus();
                                });
                }
        });
})( jQuery );



//$("select").combobox({
//	open: function(){alert("open");}
//});
//$(function() {
//        $( "#combobox" ).combobox();
//        $( "#toggle" ).click(function() {
//                $( "#combobox" ).toggle();
//        });
//        $( "#combobox2" ).combobox();
//        $( "#toggle" ).click(function() {
//                $( "#combobox2" ).toggle();
//        });
//});