(function( $ ) {
        $.widget( "ui.searchcombobox", {
                options: {
                        text: "Search your text ...",
                        textbutton: "Go"
                },
                _create: function() {
                        var self = this,
                                select = this.element.hide(),
                                selected = select.children( ":selected" ),
                                value = selected.val() ? selected.text() : "";
                        var text = this.getText();

                        var input_search = $( "<input>" )
                                .insertAfter( select )
                                .addClass("clsIptSearchValue clsBorderRBottomLeft clsBorderRTopLeft")
                                .val( text )
                                .focus(function(){
                                    if( this.value == text )
                                        this.value = "";
                                })
                                .blur(function(){
                                    if( this.value == "" )
                                        this.value = text;
                                });
                        var input = $( "<input>" )
                                .insertAfter( input_search )
                                .val( value )
                                .autocomplete({
                                        delay: 0,
                                        minLength: 0,
                                        source: function( request, response ) {
                                                var matcher = new RegExp( $.ui.autocomplete.escapeRegex(request.term), "i" );
                                                response( select.children( "option" ).map(function() {
                                                        var text = $( this ).text();
                                                        if ( this.value && ( !request.term || matcher.test(text) ) )
                                                                return {
                                                                        label: text.replace(
                                                                                new RegExp(
                                                                                        "(?![^&;]+;)(?!<[^<>]*)(" +
                                                                                        $.ui.autocomplete.escapeRegex(request.term) +
                                                                                        ")(?![^<>]*>)(?![^&;]+;)", "gi"
                                                                                ), "<strong>$1</strong>" ),
                                                                        value: text,
                                                                        option: this
                                                                };
                                                }) );
                                        },
                                        select: function( event, ui ) {
                                                ui.item.option.selected = true;
                                                self._trigger( "selected", event, {
                                                        item: ui.item.option
                                                });
                                        },
                                        change: function( event, ui ) {
                                                if ( !ui.item ) {
                                                        var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( $(this).val() ) + "$", "i" ),
                                                                valid = false;
                                                        select.children( "option" ).each(function() {
                                                                if ( this.value.match( matcher ) ) {
                                                                        this.selected = valid = true;
                                                                        return false;
                                                                }
                                                        });
                                                }
                                        }
                                })
                                .addClass( "ui-combo-input" );

                        input.data( "autocomplete" )._renderItem = function( ul, item ) {
                                return $( "<li></li>" )
                                        .data( "item.autocomplete", item )
                                        .append( "<a>" + item.label + "</a>" )
                                        .appendTo( ul );
                        };
                        var buttontext = this.getButtonText();
                        $( "<button type='submit'></button>" )
                                .attr( "tabIndex", -1 )
                                .attr( "title", "Show All Items" )
                                .insertAfter( input )
                                .button({
                                        label: buttontext,
                                        text: true
                                })
                                .removeClass( "ui-corner-all" )
                                .addClass( "ui-corner-right ui-corner-left ui-button-icon ui-combo-button" );
                        $( "<button type='button'>&nbsp;</button>" )
                                .attr( "tabIndex", -1 )
                                .attr( "title", "Show All Items" )
                                .insertAfter( input )
                                .button({
                                        icons: {
                                                primary: "ui-icon-triangle-1-s"
                                        },
                                        text: false
                                })
                                .removeClass( "ui-corner-all" )
                                .addClass( "ui-corner-right ui-button-icon ui-combo-button" )
                                .click(function() {
                                        // close if already visible
                                        if ( input.autocomplete( "widget" ).is( ":visible" ) ) {
                                                input.autocomplete( "close" );
                                                return;
                                        }

                                        // pass empty string as value to search for, displaying all results
                                        input.autocomplete( "search", "" );
                                        input.focus();
                                });
                },
                getText: function() { return this.options.text; },
                getButtonText: function() { return this.options.buttontext; },
                setText: function(text) { this.options.text = text;},
                // **CHANGE** react to option changes after initialization
                _setOption: function( key, value ) {
                        switch ( key ) {
                                case "text":
                                        this.options.text = value;
                                        break;
                                case "textbutton":
                                        this.options.textbutton = value;
                                        break;
                                default:
                                        this.options[ key ] = value;
                                        break;
                        }
                }
        });
})( jQuery );

//$(function() {
//        $( "#combobox" ).combobox();
//        $( "#toggle" ).click(function() {
//                $( "#combobox" ).toggle();
//        });
//        $( "#combobox2" ).combobox();
//        $( "#toggle" ).click(function() {
//                $( "#combobox2" ).toggle();
//        });
//});